//屏蔽了Jpush的相关插件
!function(){
  'use strict';

  var service = angular.module('app.services', [])
  service.factory('Storage', function() {
    return {
      set: function(key, data) {
        return window.localStorage.setItem(key, window.JSON.stringify(data));
      },
      get: function(key) {
        return window.JSON.parse(window.localStorage.getItem(key));
      },
      remove: function(key) {
        return window.localStorage.removeItem(key);
      }
    };
  });
  service.factory('System', function($q, $http, $log, $base64, ENV) {
    return {
      // checkUpdate: function(deviceType, platformType){
      //   var deferred = $q.defer(),
      //       promise = deferred.promise;
      //   $http({
      //     method: 'POST',
      //     url: ENV.api + '/my/info/getLatestVersion',
      //     dataType: "json",
      //     params: {
      //       device_type: deviceType,
      //       platform_type: platformType
      //     }
      //   }).success(function(res){
      //     $log.log(res);
      //     if(res && res.success){
      //       deferred.resolve(res.record);
      //     } else {
      //       //'获取数据失败, ' +
      //       deferred.reject(res.msg);
      //     }
      //   });
      //
      //   promise.success = function(fn) {
      //       promise.then(fn);
      //       return promise;
      //   }
      //   promise.error = function(fn) {
      //       promise.then(null, fn);
      //       return promise;
      //   }
      //   return promise;
      // }
      checkUpdate: function(){
        var deferred = $q.defer(),
            promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/versionUpdate/versionInfo',
          dataType: "json"
        }).success(function(res){
          $log.log(res);
          if(res && res.success){
            deferred.resolve(res.record);
          } else {
            //'获取数据失败, ' +
            deferred.reject(res.msg);
          }
        });

        promise.success = function(fn) {
            promise.then(fn);
            return promise;
        }
        promise.error = function(fn) {
            promise.then(null, fn);
            return promise;
        }
        return promise;
      }
    }
  });

  // service.factory('Jpush', function($log, ENV) {
  //   var push;
  //   return {
  //     init: function(notificationCallback) {
  //       push = window.plugins && window.plugins.jPushPlugin;
  //       if (push) {
  //         $log.debug('jpush: init');
  //         plugins.jPushPlugin.init();
  //         plugins.jPushPlugin.setStatisticsOpen(true);//开启统计
  //         plugins.jPushPlugin.setDebugMode(ENV.debug);
  //         //plugins.jPushPlugin.openNotificationInAndroidCallback = notificationCallback;
  //         plugins.jPushPlugin.receiveNotificationIniOSCallback = notificationCallback;
  //       }
  //     },
  //     setBadge: function(badge) {
  //       if (push) {
  //         $log.debug('jpush: set badge', badge);
  //         plugins.jPushPlugin.setBadge(badge);
  //       }
  //     },
  //     setAlias: function(alias) {
  //       if (push) {
  //         $log.debug('jpush: set alias', alias);
  //         plugins.jPushPlugin.setAlias(alias);
  //       }
  //     },
  //     check: function() {
  //       if (window.jpush && push) {
  //         plugins.jPushPlugin.receiveNotificationIniOSCallback(window.jpush);
  //         window.jpush = null;
  //       }
  //     }
  //   };
  // });

  service.factory('MimeType', function($log, ENV) {
    return {
      get: function(ext){
        return Stretchr.Filetypes.mimeFor(ext);
      }
    };
  });

  service.factory('LocalDragon', ['$window', function($window){

    return {
      set: function(key, value){

        $window.localStorage[key] = value;
      },
      get: function(key, defaultValue){

        return $window.localStorage[key] || defaultValue;
      },
      removeItem:function(key){

        return $window.localStorage.removeItem(key);
      },
      clearLocalStorage:function(){

        return $window.localStorage.clear();
      }
    }

  }]);

  service.service("commonService", function () {
      var _this=this;
      _this.prePageSelect="";
      return _this;
  });
}();
