/*
* @Author: HuangTiger
* @Date:   2017-06-01 15:45:34
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-06-27 15:24:00
*/

define(function (require) {
  'use strict';
  var routes = angular.module("costManagement.route", []);

  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('costManagement', {
        url: '/costManagement',
        abstract: true,
        templateUrl: 'modules/costManagement/templates/tabs-cost.html'
      })
      // .state('costManagement.list', {
      //   url: '/list',
      //   // params: {"msgId":null},
      //   cache: false,
      //   views: {
      //     'tabs-cost': {
      //       templateUrl: 'modules/costManagement/templates/list.html',
      //       controller: "CostManagementListController"
      //     }
      //   }
      // })
      // .state('costManagement.details', {
      //   url: '/details',
      //   // params: {"msgId":null},
      //   cache: false,
      //   views: {
      //     'tabs-cost': {
      //       templateUrl: 'modules/costManagement/templates/costDetails.html',
      //       controller: "CostDetailsController"
      //     }
      //   }
      // })
      // .state('costManagement.newCost', {
      //   url: '/newCost/:analysisVal/:isNewCost',
      //   params: {"item":null},
      //   cache: false,
      //   views: {
      //     'tabs-cost': {
      //       templateUrl: 'modules/costManagement/templates/newCostPage.html',
      //       controller: "NewCostController"
      //     }
      //   }
      // })
      // .state('costManagement.searchSign', {
      //   url: '/searchSign',
      //   // params: {"msgId":null},
      //   cache: false,
      //   views: {
      //     'tabs-cost': {
      //       templateUrl: 'modules/costManagement/templates/searcSign.html',
      //       controller: "SearchSignController"
      //     }
      //   }
      // })

      // 报销列表
      .state('costManagement.RBList', {
          url: '/RBList',
          views: {
            'tabs-cost': {
              templateUrl: 'modules/costManagement/templates/reimbursement/page-list.html',
              controller: "ReimbursementController"
            }
          }
      })
      // 报销新增
      .state('costManagement.addRB', {
        url: '/addRB',
        views: {
          'tabs-cost': {
            templateUrl: 'modules/costManagement/templates/reimbursement/addRB.html',
            controller: "addReimbursementController"
          }
        }
      })
      // 报销详情
      .state('costManagement.RBDetail', {
        url: '/RBDetail/:id/:type',
        views: {
          'tabs-cost': {
            templateUrl: 'modules/costManagement/templates/reimbursement/RBDetail.html',
            controller: "reimbursementDetailController"
          }
        }
      })
  });


  return routes;
});
