/*
* @Author: HuangTiger
* @Date:   2017-06-01 15:45:34
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-06-08 16:12:05
*/

define(function (require) {
  'use strict';
  var routes = angular.module("middleware.route", []);

  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('middleware', {
        url: '/middleware',
        abstract: true,
        templateUrl: 'modules/middleware/templates/tabs-details.html'
      })
      .state('middleware.details', {
        url: '/details/:id/:type/:msgId/:taskId/:startTime/:userId',
        // params: {"msgId":null},
        cache: false,
        views: {
          'tabs-details': {
            templateUrl: 'modules/middleware/templates/details.html',
            controller: "MiddlewareController"
          }
        }
      })
      .state('middleware.manage', {
        url: '/manage/:projectId/:type/:taskId/:startTime/:userId/:userName',
        params: {"isBeing":null},
        cache: false,
        views: {
          'tabs-details': {
            templateUrl: 'modules/middleware/templates/manage.html',
            controller: "ManageEditController"
          }
        }
      });
  });


  return routes;
});
