define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('ChoosePersonLiableController', function (ENV,$window, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory,$stateParams, $ionicLoading,$interval,$ionicScrollDelegate, Storage, SecurityService) {
    $scope.itemsPersonLiable=[];
    $scope.History = {
      goBack: function (name,sate,id) {

        if (!$window.localstorage && sate) {
          var storage=$window.localStorage;
           storage["personLiableKey"]=name;
           storage["personLiablIdeKey"]=id;
        }

        $ionicHistory.goBack();
      }
    };
    SecurityService.getResponsibility($stateParams.checkId,$stateParams.source,$stateParams.projectId)
    .success(function (res) {
    if(res){
           $scope.itemsPersonLiable= res;
    }
    }).error(function (res) {
      if (res.errorCode == '000002') {
        var confirmPopup =  $ionicPopup.alert({
               title: '提示信息',
               template: '该帐号已在其他设备登录！',
               okText: '确定',
               okType: 'button-assertive'
             });
        confirmPopup.then(function(res) {
          if(res) {
            Storage.remove('isLogged');
            Storage.remove('userInfo');
            Storage.remove('menuList');
            $state.go('login');
          }
        });
      }
     });
  //  $scope.itemsPersonLiable = [
  //             { id: 0, name: '冉锐',position:'项目经理'},
  //             { id: 1, name: '路飞',position:'项目负责人'}
  //         ];
  });

  return controller;
});
