define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('MailListController', function (ENV, $scope,$log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory ,$location, $http,$ionicScrollDelegate, $ionicLoading, $interval,$stateParams, Storage, MailListService,$cordovaKeyboard) {

    $scope.showNull = false;
    $scope.keyboard = {show: false};
    $scope.goBack = function() {
        $ionicHistory.goBack();
    };
    $scope.$on('$stateChangeSuccess', function() {
               $scope.keyboard = {show: false};
                  $scope.allowEdit = false;
                   $timeout(function() {
                            $scope.allowEdit = true;
                            }, 400);
            });

    //下拉刷新
    // $scope.onPullRefresh = function () {
    //
    //       $scope.$broadcast('scroll.refreshComplete');
    // };

    $scope.todoSomething=function($event){
             if($event.keyCode==13){//回车
                $cordovaKeyboard.close();
             }
     }


    $scope.org = $stateParams.org;
    $scope.title=$stateParams.title;
    $scope.adressName=$stateParams.adressName;
    $scope.data = [];
    $scope.load = function() {
      MailListService.mailList($scope.adressName,$scope.org)
      .success(function (data) {
           $scope.nameDatas = data.mailList;
           $scope.showNull = !$scope.nameDatas.length > 0;
           $scope.showMiddle=false; //是否在屏幕中央显示选中的字母索引
           $scope.hIndex=(window.screen.height-44*2-4)/26;
           $scope.indexs=[];
           // loadData();
           for(var i=0;i<$scope.nameDatas.length;i++){
               $scope.indexs.push($scope.nameDatas[i].initials);//获取字母数组
           };
           // 动态计算字母索引top高度
           var topNum =(window.screen.height-44*2 - $scope.hIndex*$scope.indexs.length)/2;
           $scope.letterTop = topNum;

      }).error(function (data) {
        if(data == null){
          $ionicLoading.show({
           template: "服务器异常，请稍后再试。",
           duration: 800
          });
        } else {
          $ionicLoading.show({
           template: data.msg,
           duration: 800
          });
        }
       });
     };
      $scope.load();
      $scope.startDot = function() {//判断清除输入框的图标是否显示
        if($scope.adressName.length==0 || $scope.adressName=="") {
            $scope.searchEmptyShow=false;
        }else{

            $scope.searchEmptyShow=true;
        }
        $scope.org="";
        $scope.data = [];
        $scope.load();
         $ionicScrollDelegate.scrollTop();
      };

      $scope.searchEmpty = function() {//点击清除输入框的图标的点击事件
          $scope.searchEmptyShow=false;
          $scope.adressName="";
      };

      $scope.mTouch = function(event) {

          var positionX=event.pageX || event.touches[0].pageX;
          var positioinY=event.pageY || event.touches[0].pageY;
          var ele = document.elementFromPoint(positionX,positioinY);
          if(!ele){
           return;
          }
          var c=ele.innerText;
          if(!c || c==" " || c.length!=1){
           return;
          }

          $scope.hint=c;

          if (document.getElementById("name_"+$scope.hint)==null) {
                return;
          };

          $scope.showMiddle=true;

          var scroll = document.getElementById("name_"+$scope.hint).offsetTop - $ionicScrollDelegate.getScrollPosition().top;
          $ionicScrollDelegate.scrollBy(0,scroll,true);//$location.hash('likes');id:likes
          //  var ele = document.getElementsByTagName("ion-content");
          //  ele[0].style.overflow="auto";
        };

        $scope.mRelease = function(event) {
          $timeout(function() {
              $scope.showMiddle=false;
          },300);
        };

       $scope.itemClicked = function (item) {
         if ($stateParams.isChooserPerson === '1'){
           Storage.set('costApprover', item);
           $ionicHistory.goBack(-2);
         }else{
           $state.go('mailListDetails',{id: item.id})
         }
       }
  });

  return controller;
});
