/*
* @Author: HuangTiger
* @Date:   2017-09-12 15:42:57
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-09-12 16:44:55
*/
define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('MailListGParentController', function (ENV, $http, $scope, $ionicHistory,$cordovaDevice,$log, $timeout, $interval, $state, $rootScope, $ionicPopup, $ionicModal, $ionicLoading, $base64,MailListService, $ionicScrollDelegate, $cordovaKeyboard, Storage,$stateParams) {

    $scope.isChooserPerson = $stateParams.isChooserPerson || false;
  	$scope.showNull = false;
    $scope.keyboard = {show: false};
    $scope.ename = "";
    $scope.title = "通讯录";
    $scope.oldTitle = "通讯录";
    $scope.goBack = function() {
        if($scope.title == "通讯录"){
          $scope.adressName="";
          $ionicHistory.goBack();
        }else {
          var index = $scope.ename .lastIndexOf("\_");
          $scope.ename  = $scope.ename.substring(0, index);
          $scope.start=0;
          $scope.limit=15;
          $scope.datalist=[];
          $scope.title = $scope.oldTitle;
          $scope.loadMore();
        }
    };
    $scope.$on('$stateChangeSuccess', function() {
               $scope.keyboard = {show: false};
                  $scope.allowEdit = false;
                   $timeout(function() {
                            $scope.allowEdit = true;
                            }, 400);
            });


    var confirmPopup;
    $scope.start=0;
    $scope.limit=15;
    $scope.datalist=[];
    $scope.loadMore = function () {
     MailListService.mailOrgList($scope.start, $scope.limit,$scope.ename)
     .success(function (res) {
     if(res){
       var records = res.list;
       $scope.start = $scope.start + records.length;;
       $scope.datalist = $scope.datalist.concat(records);
       $scope.showNull = !$scope.datalist.length > 0;
       records.length >= $scope.limit ? $scope.hasMore = true :  $scope.hasMore = false;
       $scope.$broadcast('scroll.infiniteScrollComplete');
     }
     }).error(function (res) {
       if (res.errorCode == '000002') {
         if(confirmPopup == null){
          confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
       }
      });
    };
    $scope.loadMore();

    $scope.next = function (leafNode,ename,cname,index) {
        if(leafNode==1&&index>0){
          $ionicScrollDelegate.$getByHandle('mScroll').scrollTop();
          $scope.start=0;
          $scope.limit=15;
          $scope.datalist=[];
          $scope.ename=ename;
          $scope.oldTitle = $scope.title;
          $scope.title=cname;
          $scope.loadMore();
        }else{
           $state.go('mailList',{org:ename,title:cname,adressName:'',isChooserPerson: $scope.isChooserPerson});
        }
    };

    $scope.todoSomething=function($event){
             if($event.keyCode==13){//回车
                $cordovaKeyboard.close();
             }
     }

    $scope.startDot = function() {//判断清除输入框的图标是否显示
        if($scope.adressName.length==0 || $scope.adressName=="") {
            $scope.searchEmptyShow=false;
        }else{
            $scope.searchEmptyShow=true;

           $state.go('mailList',{org:"",title:"查询",adressName:$scope.adressName,isChooserPerson: $scope.isChooserPerson});
           $scope.adressName="";
        }
    };

    $scope.searchEmpty = function() {//点击清除输入框的图标的点击事件
          $scope.searchEmptyShow=false;
          $scope.adressName="";
    };

  });

  return controller;
});
