define(['personManage.boot'], function(require){
  'use strict';

  var service = angular.module('portal.services');
  service.factory('NotCompletedNumService', function($q, $http, $log, $base64, ENV,Storage) {
    return {
      getNotCompletedNums: function () {
        var deferred = $q.defer(),promise = deferred.promise;
        $http({
          method: 'POST',
          url: ENV.api + '/notCompletedNum/getNotCompletedNums',
          dataType: "json",
          params: {
            usertoken:Storage.get('userInfo').usertoken
          }
        }).success(function (res) {
          if(res && res.success){
            deferred.resolve(res);
          } else {
            deferred.reject(res);
          }

        });
        promise.success = function (fn) {
          promise.then(fn);
          return promise;
        }
        promise.error = function (fn) {
          promise.then(null, fn);
          return promise;
        }
        return promise;
      }

    };
  });
  return service;
});
