/*
* @Author: HuangTiger
* @Date:   2017-09-13 14:45:03
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-09-14 09:48:36
*/
define(['projectList.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectList.controllers');

  controller.controller('ProListStatController', function (ENV, $window, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate,$stateParams, Storage, ProjectService) {
    $scope.History = {
      goBack: function () {

        $ionicHistory.goBack();

      }
    };
    var confirmPopup=null;
    var usertoken =  Storage.get("userInfo").usertoken;
    var projectId = $stateParams.id;

	     ProjectService.getProjectDetail(projectId,usertoken)
	     .success(function (res) {
	     	console.log(res);
		     if(res){
           $scope.project=res.project;
           $scope.iSsupervision=res.iSsupervision;
		     }
	     }).error(function (res) {
	       if (res.errorCode == '000002') {
	         if(confirmPopup == null){
	          confirmPopup =  $ionicPopup.alert({
	                title: '提示信息',
	                template: '该帐号已在其他设备登录！',
	                okText: '确定',
	                okType: 'button-assertive'
	              });
	         confirmPopup.then(function(res) {
	           if(res) {
	             Storage.remove('isLogged');
	             Storage.remove('userInfo');
	             Storage.remove('menuList');
	             $state.go('login');
	           }
	         });
	       }
	       }
	      });



  });

  return controller;
});
