/*
 * @Author: HuangTiger
 * @Date:   2017-06-05 09:24:00
 * @Last Modified by:   HuangTiger
 * @Last Modified time: 2017-07-21 17:42:35
 */

define(['qLists.boot'], function (require) {
  'use strict';

  var controller = angular.module('qLists.controllers', ['ionic', 'ui.bootstrap']);

  //问题列表
  controller.controller('QListsController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, QListsService, $state, Storage, $ionicScrollDelegate, $location,LocalDragon) {

    $scope.goHref = function(){
      $scope.initCache();
      $state.go('tabs.home.message');
    };

    //一开始初始化的变量
    // var relation = undefined;
    // $scope.isViolation = null;
    // $scope.status = null;
    // $scope.level = null;
    // $scope.type = null;

    // $scope.recordCache = function(){
    //   LocalDragon.set("qList_isViolation",$scope.isViolation);
    //   LocalDragon.set("qList_status",$scope.status);
    //   LocalDragon.set("qList_level",$scope.level);
    //   LocalDragon.set("qList_type",$scope.type);
    // };
    // $scope.clearCache = function(){
    //   LocalDragon.removeItem("qList_isViolation");
    //   LocalDragon.removeItem("qList_status");
    //   LocalDragon.removeItem("qList_level");
    //   LocalDragon.removeItem("qList_type");
    // };
    $scope.initCache = function(){
      $scope.isViolation = null;
      $scope.status = null;
      $scope.level = null;
      $scope.type = null;
    };
    // function getCatchValue(obj){
    //   if(obj && obj != null && obj != "null"){
    //     return obj
    //   }else{
    //     return null;
    //   }
    // }
    $scope.initCache();
    //筛选
    $scope.showPopupSue = function (node) {
      //处理违规
      $scope.choiceWeigui = function (str) {
        $scope.isViolation = str;
      };
      //处理问题解决的筛选
      $scope.choiceTroubel = function (str) {
        $scope.status = str;
      };
      //处理严重程度的筛选
      $scope.choiceSeverity = function (str) {
        $scope.level = str;
      };
      //处理问题分类
      $scope.choiceCategory = function (str) {
        $scope.type = str;
      };
      //无法解决冒泡的问题，只能根据情况写逻辑判断，这里拿到的是每一列中的名字
      console.log('node:', node);
      // if (node.path[0].className === 'main-word-item') {

      //   relation = node.path[1].innerText.split(' ');

      //   relation = relation[1];

      // } else if (node.path[0].className === 'pull-right-aaa') {

      //   relation = node.path[0].innerText;
      // } else {

      //   relation = node.path[0].innerText.split(' ');

      //   relation = relation[1];
      // }

      var myPopupOne = $ionicPopup.show({

        template: '<div class="list">' +

        '<div class="item mine-item">' +
        '<div>违规情况</div>' +
        '<div >' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':isViolation==null}" ng-click="choiceWeigui(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':isViolation==true}" ng-click="choiceWeigui(true)">违规</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':isViolation==false}" ng-click="choiceWeigui(false)">不违规</span></div>' +
        '</div>' +

        '<div class="item mine-item">' +
        '<div>问题状态</div>' +
        '<div >' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':status==null}" ng-click="choiceTroubel(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':status==1}" ng-click="choiceTroubel(1)">未解决</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':status==2}" ng-click="choiceTroubel(2)">已解决</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':status==3}" ng-click="choiceTroubel(3)">遗留</span></div>' +
        '</div>' +

        '<div class="item mine-item">' +
        '<div>严重程度</div>' +
        '<div >' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':level==null}" ng-click="choiceSeverity(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':level==1}" ng-click="choiceSeverity(1)">严重</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':level==2}" ng-click="choiceSeverity(2)">中等</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':level==3}" ng-click="choiceSeverity(3)">一般</span></div>' +
        '</div>' +

        '<div class="item mine-item">' +
        '<div>问题分类</div>' +
        '<div style="white-space: normal;">' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==null}" ng-click="choiceCategory(null)">全部</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==\'J\'}" ng-click="choiceCategory(\'J\')">进度</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==\'Z\'}" ng-click="choiceCategory(\'Z\')">质量</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==\'A\'}" ng-click="choiceCategory(\'A\')">安全</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==\'T\'}" ng-click="choiceCategory(\'T\')">投资</span>' +
        '<span class="re-select margin-right" ng-class="{\'selectNode\':type==\'HTGK\'}" ng-click="choiceCategory(\'HTGK\')">合同</span>' +
        '<span class="re-select" ng-class="{\'selectNode\':type==\'QT\'}" ng-click="choiceCategory(\'QT\')">其他</span></div>' +
        '</div>' +
        '</div>',
        title: '筛选',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            onTap: function () {
              $scope.initCache();
              return false;
            }
          },
          {
            text: '<b>确定</b>',
            type: 'button-positive',
            onTap: function (e) {
              // $scope.recordCache();
              $scope.datalist = [];
              $scope.start = 0;
              $scope.hasMore = false;
              $scope.loadMore();
              $location.hash('likes');
              $ionicScrollDelegate.anchorScroll(true);
              return false;
            }
          }
        ]
      });

      myPopupOne.then(function (res) {

        if (!res) {

          return false;
        } else {

          console.log('Tapped!');
          //TODO

        }

      });

    };

    $scope.datalist = [];
    $scope.start = 0;
    $scope.limit = 50;
    $scope.showNull = false;
    $scope.conSupport = [];

    $scope.onPullDown = function () {
      // $scope.initCache();
      $scope.conSupport = [];
      $scope.start = 0;
      $scope.datalist = [];
      $scope.loadMore()
    }

    $scope.loadMore = function () {
      QListsService.getTroubleList($scope.start, $scope.limit, $scope.isViolation, $scope.status, $scope.level, $scope.type)
        .success(function (res) {

          // console.log('res:', res);
          if (res ) {
              console.log(222);
            //有数据
            $scope.showNull = false;

            var records = res.record;
            $scope.start = $scope.start + records.length;
            $scope.datalist = $scope.datalist.concat(records);

            // console.log('$scope.datalist:', $scope.datalist);

            //变相控制列表点击是否展示内容

            for(var it in records){

              $scope.conSupport[records[it].projectId] = false;
            }

            if (records.length >= $scope.limit) {
              $scope.hasMore = true;
            } else {
              $scope.hasMore = false;
            }

          }
          if($scope.datalist.length == 0){
            $scope.showNull = true;
          }
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }).error(function (data) {
          //无数据
          if($scope.datalist.length == 0){
            $scope.showNull = true;
          }
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };
    $scope.loadMore();

  });

  //问题详情
  controller.controller('QDetailsController', function (ENV, $window,$scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $stateParams, QListsService, $state, Storage, $ionicHistory, $ionicActionSheet,$filter) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };

    $scope.troubleId = $stateParams.troubleId;
    $scope.source = $stateParams.source;
    $scope.qaq = true;
    $scope.recordList = [];
    $scope.imgShou = [];
    $scope.soDoImg = [];
    $scope.activeImgIndex = undefined;
    var bigShowImg = [];

    // var storage=$window.localStorage;
    // if (!$window.localstorage) {
    //   var qDKey=storage.qDKey;
    //   if (!qDKey) {
    //     storage["qDKey"]=$stateParams.state;
    //   }
    // };
    //
    // $scope.goBack = function() {
    //
    //   if (!$window.localstorage) {
    //
    //     var goState=storage.qDKey;
    //     if (goState == 0) {
    //         $state.go("qLists.list");
    //     }
    //     else if (goState == 1) {
    //         $state.go("pdacDetails");
    //     }else {
    //         $state.go("tabs.home.message");
    //     }
    //     storage.removeItem("qDKey");
    //   }
    // };
    var singleConfirmPopup = null;
    $scope.getTrouble = function () {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      QListsService.getTrouble($scope.troubleId)
        .success(function (res) {
          $ionicLoading.hide();
          if (res && res.record) {
            $scope.troubleDetail = res.record;
            // console.log('$scope.troubleDetail:', $scope.troubleDetail);

            //提供给checkbox 批量删除的flag
            for (var i = 0; i < res.record.troubleRecordList.length; i++) {
              $scope.recordList[i] = false;
            }

            //有人说你一个人到处旅行走走停停---多图片预览图片展示前戏
            for (var i = 0; i < res.record.troubleRecordList.length; i++) {
              $scope.imgShou[i] = [];
              for (var j = 0; j < res.record.troubleRecordList[i].attachmentList.length; j++) {

                $scope.imgShou[i][j] = ENV.api + '/file/getPic?id='+ res.record.troubleRecordList[i].attachmentList[j].id  +'&isCompress=false';
              }
            }

            //非评论区的图片
            for (var i = 0; i < $scope.troubleDetail.attachmentList.length; i++) {

              bigShowImg[i] = ENV.api + '/file/getPic?id=' + $scope.troubleDetail.attachmentList[i].id + '&isCompress=false';
            }

            // console.log('$scope.imgShou:', $scope.imgShou);
          }
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            if(singleConfirmPopup == null){
              singleConfirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
              singleConfirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            }
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };

    $scope.getTrouble();

    $scope.isShowfollowUpBtn = false;
    $scope.isShowSuperviseBtn = false;

    QListsService.getFollowUpAndSupervisePower($scope.troubleId)
      .success(function (res) {
        if (res && res.record) {
          $scope.isShowfollowUpBtn = res.record.isShowfollowUpBtn;
          $scope.isShowSuperviseBtn = res.record.isShowSuperviseBtn;
        }
      }).error(function (data) {
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(singleConfirmPopup == null){
            singleConfirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            singleConfirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });

    //一开始初始化的变量
    var relation = undefined;
    var calendar2 = new datePicker();

    $scope.detailsFlag = true;


    $scope.sDate2 = function () {

      //测试了9个插件后，还是用回原生插件
      $timeout(function () {

        calendar2.init({
          'trigger': '#dateSelect2',
          'type': 'date',
          'minDate': '1900-1-1',
          'maxDate': '2100-12-31',
          'onSubmit': function () {
            //$scope.superviseTime.superviseTime = calendar2.value;
          },
          /*取消时触发事件*/
          'onClose': function () {
          }
        });
      }, 0);

    }

    $scope.superviseTime = {superviseTime:""};
    $scope.superviseNote = {superviseNote:""};

    //督办的对话框
    $scope.showPopupSupervise = function (node) {
      $scope.superviseTime.superviseTime = $filter('date')(new Date(),'yyyy-MM-dd');
      $scope.superviseNote.superviseNote = "";
      var myPopupOne = $ionicPopup.show({
        template: '<div style="overflow:hidden;margin-bottom: 10px;"><span style="line-height: 34px;">督办时限</span><span style="color:#1646c0;float:right;">' +

        '<input type="text" ng-model="superviseTime.superviseTime" placeholder="请选择日期" id="dateSelect2" readonly="readonly"/></span></div>' +
        '<div style="overflow:hidden;"><span style="line-height: 34px;">督办备注</span><span style="color:#1646c0;float:right;">' +
        '<input type="text" ng-model="superviseNote.superviseNote" placeholder="请输入备注" />' +
        '</span></div>',
        title: '督办详情',
        scope: $scope,
        buttons: [
          {
            text: '取消',
            onTap: function () {
              return false;
            }
          },
          {
            text: '<b>确定</b>',
            type: 'button-assertive',
            onTap: function () {
              if ($scope.superviseTime.superviseTime == "") {
                $scope.showAlert("请选择日期");
                return true;
              }
              if ($scope.superviseNote.superviseNote == "") {
                $scope.showAlert("请填写备注");
                return true;
              }
              $ionicLoading.show({
                template: '提交中，请稍候...',
                noBackdrop: true
              });
              QListsService.doSupervise($scope.troubleId, $scope.superviseNote.superviseNote, $scope.superviseTime.superviseTime)
                .success(function (res) {
                  $ionicLoading.hide();
                  var myPopupChild = $ionicPopup.show({
                    template: '<div class="popText">督办成功</div>',
                    title: '提示',
                    cssClass: 'popText',
                    scope: $scope
                  });
                  $timeout(function () {
                    myPopupChild.close();
                    $scope.getTrouble();
                  }, 1000);
                }).error(function (data) {
                  $ionicLoading.hide();
                  if (data == null) {
                    $ionicLoading.show({
                      template: "服务器异常，请稍后再试。",
                      duration: 800
                    });
                  } else if (data.errorCode == '000002') {
                    var confirmPopup =  $ionicPopup.alert({
                      title: '提示信息',
                      template: '该帐号已在其他设备登录！',
                      okText: '确定',
                      okType: 'button-assertive'
                    });
                    confirmPopup.then(function(res) {
                      if(res) {
                        Storage.remove('isLogged');
                        Storage.remove('userInfo');
                        Storage.remove('menuList');
                        $state.go('login');
                      }
                    });
                  } else {
                    $ionicLoading.show({
                      template: data.msg,
                      duration: 800
                    });
                  }
                });

            }
          }
        ]
      });

      $scope.showAlert = function (message, title) {
        $ionicPopup.alert({
          title: title || '提示信息',
          template: message,
          okText: '确定',
          okType: 'button-calm'
        });
      };
    };

      //展示图片假数据
      // $scope.imgs = [

      //   'modules/qLists/img/add.png'
      // ];
      $scope.bigImage = false;
      $scope.hideBigImage = function () {

        $scope.bigImage = false;
      };

      //点击图片放大
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = '/file/getPic?id='+item.id+'&isCompress=false';
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, ENV.api, function (success) {
        }, function (error) {
        }
      );
    };
      //右上角的问题删除操作
      $scope.deleteItem = function(node){


         // 显示上拉菜单
         var hideSheet = $ionicActionSheet.show({

           destructiveText: '确定',
           cancelText: '取消',
           cancel: function() {
                // 这里添加取消代码
              },
           destructiveButtonClicked: function(index) {

             clearTimeout(letGo);
             var letGo = setTimeout(function(){

                $state.go('qLists.list');
             }, 50);
             //TODO

             return true;
           }
         });

      };

      //问题进度里头的删除按钮
      $scope.delFlag = false;
      $scope.showBtnGG = function(node){

          $scope.delFlag = !$scope.delFlag;

      };

      //批量删除
      $scope.checkboxHi = false;
      $scope.delTogerther = function(){

        var hellowDelman = $scope.recordList;
        //判断是否选择了元素
        var selectTure = (function(){
          return hellowDelman.some(function(value, index){
            return value === true;

          });
        }());

        //如果没选，弹出提示
        if (!selectTure) {

            // 自定义弹窗
            var myPopup = $ionicPopup.show({
              template: '<div style="text-align:center;">勾选为空</div>',
              scope: $scope
            });
            $timeout(function() {
               myPopup.close();
            }, 1000);
        }
      };
  });


  //问题跟进
  controller.controller('QFollowUpController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal, $state, $stateParams, $ionicActionSheet, QListsService, Storage,$ionicHistory,$cordovaImagePicker) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.troubleId = $stateParams.troubleId;
    var middleJ = '';
    var stateM = $stateParams.statement;

    if (stateM == 1) {
      middleJ = '未解决';
      $scope.initialState = '未解决';

      $scope.notJ = true;
      $scope.isJ = false;
      $scope.stayJ = false;
    } else if (stateM == 3) {

      middleJ = '遗留问题';
      $scope.initialState = '遗留问题';

      $scope.notJ = false;
      $scope.isJ = false;
      $scope.stayJ = true;
    } else if (stateM == 2) {

      middleJ = '已解决';
      $scope.initialState = '已解决';

      $scope.notJ = false;
      $scope.isJ = true;
      $scope.stayJ = false;
    }


    $scope.sDone = function (str) {

      if (str == 'notJ') {

        $scope.notJ = true;
        $scope.isJ = false;
        $scope.stayJ = false;

        middleJ = '未解决';
      } else if (str === 'isJ') {

        $scope.notJ = false;
        $scope.isJ = true;
        $scope.stayJ = false;

        middleJ = '已解决';
      } else {

        $scope.notJ = false;
        $scope.isJ = false;
        $scope.stayJ = true;

        middleJ = '遗留问题';
      }
    };

    $scope.showPopupFollowUp = function (node) {
      var myPopupOne = $ionicPopup.show({
        template: '<div class="item mine-item" ng-click="sDone(\'notJ\')"><span class="icon pull-right-5" style="margin-top: 0px;font-size: 16px !important;color:#51bb7d;" ng-class=\'{true: "ion-android-done", false:""}[notJ]\'></span>' +
        '<span class="main-word-item">未解决</span>' +
        '</div>' +
        '<div class="item mine-item" ng-click="sDone(\'isJ\')"><span class="icon pull-right-5" style="margin-top: 0px;font-size: 16px !important;color:#51bb7d;" ng-class=\'{true: "ion-android-done", false:""}[isJ]\'></span>' +
        '<span class="main-word-item">已解决</span>' +
        '</div>' +
        '<div class="item mine-item" ng-click="sDone(\'stayJ\')"><span class="icon pull-right-5" style="margin-top: 0px;font-size: 16px !important;color:#51bb7d;" ng-class=\'{true: "ion-android-done", false:""}[stayJ]\'></span>' +
        '<span class="main-word-item">遗留问题</span>' +
        '</div>',
        title: '请选择',
        scope: $scope,
        buttons: [
          {
            text: '<b>确定</b>',
            type: 'button-assertive',
            onTap: function (e) {
              return true;
            }
          }
        ]
      });

      myPopupOne.then(function (res) {
        if (!res) {
          return false;
        } else {
          $scope.initialState = middleJ;
        }

      });
    }

    $scope.description = {description:''};

    /*图片上传*/
    $scope.imgs = [];

    $scope.bigImage = false;
      $scope.hideBigImage = function () {

        $scope.bigImage = false;
      };

      //点击图片放大
    $scope.shouBigImage = function (list,index) {
      var arr = [];
      list.forEach(function (item) {
        var o = {};
        o.picUrl = item;
        arr.push(o);
      });
      PicturePreview.picturePreview(arr, index, '', function (success) {
        }, function (error) {
        }
      );
    };

    $scope.onSubmit = function () {
      var status = 0;
      if ($scope.notJ) {
        status = 1;
      } else if ($scope.isJ) {
        status = 2;
      } else if ($scope.stayJ) {
        status = 3;
      }
      if ($scope.description.description == "") {
        $scope.showAlert("请填写问题描述");
        return;
      }

      $ionicLoading.show({
        template: '提交中，请稍候...',
        noBackdrop: true
      });
      QListsService.doFollowUp($scope.troubleId,status,$scope.description.description)
        .success(function (res) {
          var recordId = res.record.id;
          var imgArr = $scope.imgs;
          if (imgArr.length == 0) {// 没有图片
            $timeout(function () {
              $ionicLoading.hide();
              $scope.History.goBack();
            }, 1000);
          } else {// 有图片
            angular.forEach(imgArr, function (data, index, array) {
              //data等价于array[index]
              var fileURL = data;
              if (index == imgArr.length - 1) {  // 是否是最后一张
                $scope.upload(fileURL,recordId, true);
              } else {
                $scope.upload(fileURL,recordId, false);
              }
            });
          }
        }).error(function (data) {
          $ionicLoading.hide();
          if (data == null) {
            $ionicLoading.show({
              template: "服务器异常，请稍后再试。",
              duration: 800
            });
          } else if (data.errorCode == '000002') {
            var confirmPopup =  $ionicPopup.alert({
              title: '提示信息',
              template: '该帐号已在其他设备登录！',
              okText: '确定',
              okType: 'button-assertive'
            });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          } else {
            $ionicLoading.show({
              template: data.msg,
              duration: 800
            });
          }
        });
    };


    $scope.onAddPic = function () {
      //if ($scope.imgs.length >= 9) {
      //  $scope.showAlert("上传图片数量上限");
      //  return;
      //}
      $ionicActionSheet.show({
        buttons: [
          {text: '立即拍摄'},
          {text: '从相册中选择'}
        ],
        titleText: '请选择图片来源',
        cancelText: '返回',
        cancel: function () {
          $log.log('cancel');
        },
        buttonClicked: function (index) {
          switch (index) {
            case 0:
              $scope.onTakePhoto();  // 调用照相功能
              break;
            case 1:
              $scope.onAddFromAlbum();  // 调用选择图片功能
              break;
            default:
              break;
          }
          return true;
        }
      });
    };

    //$scope.onAddFromAlbum = function () {
    //  var options = {
    //    quality: 100,
    //    destinationType: Camera.DestinationType.FILE_URI,
    //    sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
    //    encodingType: Camera.EncodingType.JPEG,
    //    mediaType: Camera.MediaType.PICTURE,
    //    targetHeight: 450,
    //    targetWidth: 350
    //  };
    //  navigator.camera.getPicture(function (fileURL) {
    //      $scope.imgs.push(fileURL);   // 向数组的末尾添加一个或多个元素，并返回新的长度。
    //      $scope.$apply();  // 如果你在AngularJS上下文之外的任何地方修改了model，那么你就需要通过手动调用$apply()来通知AngularJS
    //    },
    //    function () {//if error
    //    },
    //    options);
    //};
    $scope.onAddFromAlbum = function () {
      var options = {
        maximumImagesCount: 9, //需要显示的图片的数量
        width: 800,
        height: 800,
        quality: 100
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (results) {
          if(Array.isArray(results)) {
            for (var i = 0; i < results.length; i++) {
              $scope.imgs.push(results[i]);
            }
            $scope.$apply();
          }
        }, function(error) {
          // error getting photos
        });

    };

    // 照相功能
    $scope.onTakePhoto = function () {
      var options = {
        quality: 100,
        destinationType: Camera.DestinationType.FILE_URI,
        //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
        encodingType: Camera.EncodingType.JPEG,
        mediaType: Camera.MediaType.PICTURE,
        targetHeight: 450,
        targetWidth: 350
      };
      navigator.camera.getPicture(function (fileURL) {
          $scope.imgs.push(fileURL);
          $scope.$apply();
        },
        function () {//if error
        },
        options);
    };

    // 删除图片
    $scope.deleteImg = function (index) {
      var confirmPopup = $ionicPopup.confirm({
        title: '删除图片',
        template: '确定删除第' + (index + 1) + '张图片吗?',
        cancelText: '取消',
        cancelType: 'button-light',
        okText: '确定',
        okType: 'button-assertive'
      });
      confirmPopup.then(function (res) {
        if (res) {
          $scope.imgs.splice(index, 1);
          $scope.$apply();
        } else {
          console.log('You are not sure');
        }
      });
    };
    $scope.upload = function (fileURL,recordId, final) {
      var options = new FileUploadOptions();
      options.fileKey = "file";
      options.fileName = fileURL.substr(fileURL.lastIndexOf('/') + 1);
      if(options.fileName.indexOf('?') != -1){
        options.fileName = options.fileName.substring(0,options.fileName.indexOf('?'));
      }
      options.mimeType = "image/jpeg";
      var params = {
        usertoken: Storage.get('userInfo').usertoken,
        tableId: recordId,
        tableName: "cm_trouble_record",
        fileSource: 2,
        category: 5
      };
      options.params = params;
      var ft = new FileTransfer();
      ft.upload(
        fileURL,
        encodeURI(ENV.api + "/trouble/doUploadPic"),
        function(){
          if (final) {//如果是最后一张
            $timeout(function () {
              $ionicLoading.hide();
              $scope.History.goBack();
            }, 1000);
          }
        },
        function () {//失败
          console.log("图片上传失败");
          $ionicLoading.hide();
        },
        options
      );
    };
    $scope.showAlert = function (message, title) {
      $ionicPopup.alert({
        title: title || '提示信息',
        template: message,
        okText: '确定',
        okType: 'button-assertive'
      });
    };
  });

  return controller;

});
