/*
* @Author: HuangTiger
* @Date:   2017-06-01 15:45:34
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-06-08 14:50:09
*/

define(function (require) {
  'use strict';
  var routes = angular.module("qLists.route", []);

  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
      .state('qLists', {
        url: '/qLists',
        abstract: true,
        templateUrl: 'modules/qLists/templates/tabs.html'
      })
      .state('qLists.list', {
        url: '/list',
        // cache: false,
        views: {
          'tabs-qlists': {
            templateUrl: 'modules/qLists/templates/list.html',
            controller: "QListsController"
          }
        }
      })
      .state('qLists.details', {
        url: '/details/:troubleId/:source',
        cache: false,
        views: {
          'tabs-qlists': {
            templateUrl: 'modules/qLists/templates/details.html',
            controller: "QDetailsController"
          }
        }
      })
      .state('qLists.followUp', {
        url: '/followUp/:statement/:troubleId/',
        cache: false,
        views: {
          'tabs-qlists': {
            templateUrl: 'modules/qLists/templates/followUp.html',
            controller: "QFollowUpController"
          }
        }
      });
  });


  return routes;
});
