define(['safetyCheckRecord.boot'], function (require) {
  'use strict';

  var controller = angular.module('safetyCheckRecord.controllers');

  controller.controller('SafetyCheckRecordController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$stateParams, Storage, SafetyCheckRecordService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.rbtn = false;
    $scope.redRepDotOne = true;

    $scope.itemsAll = [];
          $scope.offMenu = function () {
            $scope.rbtn = false;
          };
          $scope.openScreen = function () {
            $scope.rbtn = !$scope.rbtn;
          };
          $scope.isSolve = 0;
          $scope.lookMenuOne = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = true;
            $scope.redRepDotTwo = false;
            $scope.redRepDotThree = false;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.limit =15;
            $scope.isSolve = 0;
            $scope.loadMore();
          };
          $scope.lookMenuTwo = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = false;
            $scope.redRepDotTwo = true;
            $scope.redRepDotThree = false;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.isSolve = 1;
            $scope.limit =15;
            $scope.loadMore();
          };
          $scope.lookMenuThree = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = false;
            $scope.redRepDotTwo = false;
            $scope.redRepDotThree = true;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.limit =15;
            $scope.isSolve = 2;
            $scope.loadMore();
          };
          $scope.datalist=[];
          $scope.start = 0;
          $scope.limit =15;
          $scope.showNull = false;
          $scope.isSolve = $stateParams.isSolve;
          $scope.source = $stateParams.source;
          $scope.checkType = $stateParams.checkType;
          if($scope.checkType==1){
            $scope.title="质量检查记录";
          }else{
            $scope.title="安全检查记录";
          }
          var usertoken =  Storage.get("userInfo").usertoken;
          $scope.loadMore = function () {
           SafetyCheckRecordService.getCheckRecordList($scope.start, $scope.limit,$scope.source,$scope.checkType,$scope.isSolve,usertoken)
           .success(function (res) {
           if(res){
             var records = res.list;
             $scope.start = $scope.start + records.length;;
             $scope.datalist = $scope.datalist.concat(records);
             $scope.showNull = !$scope.datalist.length > 0;
           if( records.length >= $scope.limit){
             $scope.hasMore = true;
           } else{
             $scope.hasMore = false;
           }
           $scope.$broadcast('scroll.infiniteScrollComplete');
           }
           }).error(function (res) {
             if (res.errorCode == '000002') {
               var confirmPopup =  $ionicPopup.alert({
                      title: '提示信息',
                      template: '该帐号已在其他设备登录！',
                      okText: '确定',
                      okType: 'button-assertive'
                    });
               confirmPopup.then(function(res) {
                 if(res) {
                   Storage.remove('isLogged');
                   Storage.remove('userInfo');
                   Storage.remove('menuList');
                   $state.go('login');
                 }
               });
             }
            });
          };
          $scope.loadMore();

  });

  return controller;
});
