define(['safetyCheckRecord.boot'], function (require) {
  'use strict';

  var controller = angular.module('safetyCheckRecord.controllers');

  controller.controller('SafetyCheckRecordDetailsController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$stateParams, Storage, SafetyCheckRecordService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.rbtn = false;
    $scope.redRepDotOne = true;

    $scope.itemsAll = [
              {
                projectId: 0,
                projectName: '实施计划检查(1)',
                createdTime:'2015-12-16',
                staffName :'霍强',
                status : "1"
              },
              {
                projectId: 0,
                projectName: '',
                createdTime:'2015-12-16',
                staffName :'霍强',
                status : "2"
              },
              {
                projectId: 0,
                projectName: '',
                createdTime:'2015-12-16',
                staffName :'霍强',
                status : "2"
              },
              {
                projectId: 1,
                projectName: '文档内容检查(2)',
                createdTime:'2015-12-16',
                staffName :'霍强',
                status : "1"
              }
          ];

          $scope.offMenu = function () {
            $scope.rbtn = false;
          };
          $scope.openScreen = function () {
            $scope.rbtn = !$scope.rbtn;
          };
          $scope.isSolve = 0;
          $scope.lookMenuOne = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = true;
            $scope.redRepDotTwo = false;
            $scope.redRepDotThree = false;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.limit =15;
            $scope.isSolve = 0;
            $scope.loadMore();
          };
          $scope.lookMenuTwo = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = false;
            $scope.redRepDotTwo = true;
            $scope.redRepDotThree = false;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.isSolve = 1;
            $scope.limit =15;
            $scope.loadMore();
          };
          $scope.lookMenuThree = function () {
            $scope.rbtn = false;
            $scope.redRepDotOne = false;
            $scope.redRepDotTwo = false;
            $scope.redRepDotThree = true;
            $scope.datalist=[];
            $scope.start = 0;
            $scope.limit =15;
            $scope.isSolve = 2;
            $scope.loadMore();
          };


          $scope.datalist=[];
          $scope.start = 0;
          $scope.limit =15;
          $scope.showNull = false;
          $scope.checkId = $stateParams.checkId;
          $scope.source = $stateParams.source;
          var usertoken =  Storage.get("userInfo").usertoken;
          $scope.loadMore = function () {
           SafetyCheckRecordService.getCheckRecordListByCheckId($scope.start, $scope.limit,$scope.checkId,$scope.source,$scope.isSolve,usertoken)
           .success(function (res) {
           if(res){
            // console.log('res:', res);
             var records = res.list;
             $scope.showNull = !records.length > 0;
             $scope.start = $scope.start + records.length;;
             $scope.datalist = $scope.datalist.concat(records);
           if( records.length >= $scope.limit){
             $scope.hasMore = true;
           } else{
             $scope.hasMore = false;
           }
           $scope.$broadcast('scroll.infiniteScrollComplete');
           }
           }).error(function (res) {
             if (res.errorCode == '000002') {
               var confirmPopup =  $ionicPopup.alert({
                      title: '提示信息',
                      template: '该帐号已在其他设备登录！',
                      okText: '确定',
                      okType: 'button-assertive'
                    });
               confirmPopup.then(function(res) {
                 if(res) {
                   Storage.remove('isLogged');
                   Storage.remove('userInfo');
                   Storage.remove('menuList');
                   $state.go('login');
                 }
               });
             }
            });
          };
          $scope.loadMore();


  });

  return controller;
});
