define(function (require) {
    'use strict';

    var routes = angular.module("workloadReporting.route", []);

    routes.config(function ($stateProvider, $urlRouterProvider) {
      $stateProvider
      //主路径 工程量
      .state('workloadReporting', {
        url: '/workloadReporting',
        cache:false,
        templateUrl: 'modules/workloadReporting/templates/workloadReporting.html',
        controller: "WorkloadReportingController"
      })

      //工程量填报项列表
      .state('workloadReportingDetails', {
        url: '/workloadReportingDetails/:id/:type',
        cache:false,
        templateUrl: 'modules/workloadReporting/templates/workloadReportingDetails.html',
        controller: "WorkloadReportingDetailsController"
      })

    });

    return routes;
});
