define(function (require) {
  'use strict';

  var routes = angular.module("communication.route", []);

  routes.config(function ($stateProvider, $urlRouterProvider) {
    $stateProvider
    //交流中心列表
      .state('communication', {
        url: '/communication',
        templateUrl: 'modules/communication/templates/communication.html',
        controller: "CommunicationRecordController"
      })
      //发帖
      .state('addCommunication', {
        url: '/addCommunication',
        cache: false,
        templateUrl: 'modules/communication/templates/addCommunication.html',
        controller: "AddCommunicationController"
      })
      //详情
      .state('communicationDetail', {
        url: '/communicationDetail/:id',
        cache: false,
        templateUrl: 'modules/communication/templates/communicationDetail.html',
        controller: "CommunicationDetailController"
      })
      //回复
      .state('communicationReplay', {
        url: '/communicationReplay/:id',
        cache: false,
        templateUrl: 'modules/communication/templates/communicationReplay.html',
        controller: "CommunicationReplayController"
      })
  });

  return routes;
});
