define(['personManage.boot'], function (require) {
  'use strict';

  var controller = angular.module('personManage.controllers');

  controller.controller('PersonnelProjectController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$stateParams, Storage, PersonnelService ) {
    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };

    $ionicLoading.show({
      template: '加载中，请稍候...',
      noBackdrop: true
    });

    $scope.rbtn = false;
    $scope.redRepDotOne = true;
    $scope.datalist=[];
    $scope.start = 0;
    $scope.limit =15;
    $scope.visibleStatus = 0;
    $scope.offMenu = function () {
      $scope.rbtn = false;
    };
    $scope.toggleMenu = function () {
      $scope.rbtn = !$scope.rbtn;
    };
    $scope.lookMenuOne = function () {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      $scope.rbtn = false;
      $scope.redRepDotOne = true;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = false;
      $scope.visibleStatus = 0;
      $scope.start = 0;
      $scope.datalist=[];
      $scope.loadMore();
    };
    $scope.lookMenuTwo = function () {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = true;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = false;
      $scope.visibleStatus = 3;
      $scope.start = 0;
      $scope.datalist=[];
      $scope.loadMore();
    };
    $scope.lookMenuThree = function () {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = true;
      $scope.redRepDotFour = false;
      $scope.visibleStatus = 1;
      $scope.start = 0;
      $scope.datalist=[];
      $scope.loadMore();
    };
    $scope.lookMenuFour = function () {
      $ionicLoading.show({
        template: '加载中，请稍候...',
        noBackdrop: true
      });
      $scope.rbtn = false;
      $scope.redRepDotOne = false;
      $scope.redRepDotTwo = false;
      $scope.redRepDotThree = false;
      $scope.redRepDotFour = true;
      $scope.visibleStatus = 4;
      $scope.start = 0;
      $scope.datalist=[];
      $scope.loadMore();
    };

    $scope.userId = $stateParams.userId;
    $scope.loadMore = function () {
     PersonnelService.projectListByUser($scope.visibleStatus,$scope.start, $scope.limit,$scope.userId)
     .success(function (res) {
     if(res){
       var records = res.projectList;
       $scope.start = $scope.start + records.length;;
       $scope.datalist = $scope.datalist.concat(records);
       $scope.showNull = !$scope.datalist.length > 0;
     if( records.length >= $scope.limit){
       $scope.hasMore = true;
     } else{
       $scope.hasMore = false;
     }
     $ionicLoading.hide();
     $scope.$broadcast('scroll.infiniteScrollComplete');
     }
     }).error(function (res) {
       $ionicLoading.hide();
       if (res.errorCode == '000002') {
         var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
         confirmPopup.then(function(res) {
           if(res) {
             Storage.remove('isLogged');
             Storage.remove('userInfo');
             Storage.remove('menuList');
             $state.go('login');
           }
         });
       }
      });

    };
    $scope.loadMore();
  });

  return controller;
});
