define(function (require) {
    'use strict';

    var routes = angular.module("personManage.route", []);

    routes.config(function ($stateProvider, $urlRouterProvider) {
      $stateProvider
      //主路径 人员管理
      .state('plm', {
        url: '/plm',
        templateUrl: 'modules/personManage/templates/personnelManagement.html',
        controller: "PersonnelManagementController"
      })
      //项目列表
      .state('perProject', {
        url: '/perProject/:userId',
        templateUrl: 'modules/personManage/templates/personnelProject.html',
        controller: "PersonnelProjectController"
      })

     // 子项进程
     .state('subkey', {
       url: '/subkey/:userId/:projectId',
       templateUrl: 'modules/personManage/templates/subkey.html',
       controller: "SubkeyController"
     })

     // 任务详情
     .state('personnelManagementFetails', {
       url: '/personnelManagementFetails/:taskId/:name/:source',
       templateUrl: 'modules/personManage/templates/personnelManagementFetails.html',
       controller: "PersonnelManagementFetailsController"
     })

     // 问题列表
     .state('taskQLists', {
       url: '/taskQLists/:taskId',
       templateUrl: 'modules/personManage/templates/questionList.html',
       controller: "TaskQListsController"
     })
    });

    return routes;
});
