/**
 * @Author:      LufeiBoy
 * @DateTime:    null
 * @Description: 安全检查的controller
 * @Last Modified By:   LufeiBoy
 * @Last Modified Time:    null
 */
define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');

  controller.controller('SecurityCheckController', function (ENV,$window,$ionicActionSheet, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory ,$location, $cordovaImagePicker,$http,$ionicScrollDelegate, $ionicLoading, $stateParams, Storage, SecurityService) {

     $scope.goBack = function() {
         $ionicHistory.goBack();
     };
     var   confirmPopup=null;

    // 一开始初始化的变量
    var relateDate = '2017-07-08';
    // 记录所选问题列
    var indexNum = 0;
    var isProblemChild = false;
    var isjianchaType = false;
    var personLiable = "";// 责任人
    var rectificationTimeLimit = "";// 整改时限
    var manId = "";
    var manName = "";
    $scope.violationType='';
    $scope.questionType = [];
    $scope.imgs = [];
    var arrayObj = [{},{}];// 是否通过
    var arrayObjChild = [{},{}];// 是否违规
    var arrayObjChildStype = [{},{}];// 检查类型
    $scope.check={
      isPresent:'1',
      Description : '',
      checkId:'',
      checkName:'',
      company:'',
      level:'',
      projectId:'',
      responsibility:'',
      rectificationTime:'',
      source:'',
      type:'',
      status:'1',
      violationType:'',
      violationItme:'',
      checkType:''
    };

    //默认初始化安置检查项
    SecurityService.getCheck($stateParams.checkId,$stateParams.source)
    .success(function (res) {
    if(res){
          $scope.check.checkId = res.checkId;
          $scope.check.checkName = res.checkName;
          $scope.check.company = res.company;
          $scope.check.source = res.source;
          $scope.check.projectId = res.projectId;
    }
    }).error(function (res) {
      if (res.errorCode == '000002') {
        if(confirmPopup==null){
         confirmPopup =  $ionicPopup.alert({
               title: '提示信息',
               template: '该帐号已在其他设备登录！',
               okText: '确定',
               okType: 'button-assertive'
             });
        confirmPopup.then(function(res) {
          if(res) {
            Storage.remove('isLogged');
            Storage.remove('userInfo');
            Storage.remove('menuList');
            $state.go('login');
          }
        });
      }
      }
     });

   $scope.items = [
             { id: 0, name: '问题类型'},
             { id: 1, name: '严重程度'},
             { id: 2, name: '责任人'},
             { id: 3, name: '整改时限'},
             { id: 3, name: '是否违规'}
         ];
   $scope.itemsChild = [
             { id: 0, name: '违规类型'},
             { id: 1, name: '违规事项'}
         ];
   // 确定
   $scope.clickSure = function () {
       // 提交成功后，记得删除本地personLiableKey数据
       // storage.removeItem("personLiableKey");
       var chooseMore1 =document.getElementById("choose_"+0);
       var chooseMore2 =document.getElementById("choose_"+1);
       var chooseMore3 =document.getElementById("choose_"+2);
       var chooseMore4 =document.getElementById("choose_"+3);
       var chooseMore5 =document.getElementById("chooseChild_"+0);
       var chooseMore6 =document.getElementById("chooseChild_"+1);
       var chooseMore7 =document.getElementById("123");
       var defaultStr = "请选择";
       var textareaVal=document.getElementById("textareaVal");
       if (chooseMore7.innerHTML == defaultStr) {
         $scope.showAlert("请填写检查类型");
         return;
       }else{
        $scope.check.checkType = arrayObjChildStype[0]["id"];
       }
       if (textareaVal.value == "") {
         $scope.showAlert("请填写检查评价");
         return;
       }else {
         $scope.check.Description = textareaVal.value;
       };
       if (!$scope.pushNotification2.checked2) {
         if (chooseMore1.innerHTML == defaultStr) {
           $scope.showAlert("请填写问题类型");
           return;
         }else {
           $scope.check.type = arrayObj[0].id;
         };
         if (chooseMore2.innerHTML == defaultStr) {
           $scope.showAlert("请填写严重程度");
           return;
         }else {
           $scope.check.level = arrayObj[1].id;
         };
         if (chooseMore3.innerHTML == defaultStr) {
           $scope.showAlert("请填写责任人");
           return;
         }else {
           $scope.check.responsibility = $scope.manId;
         };
         if (chooseMore4.innerHTML == defaultStr) {
           $scope.showAlert("请填写整改时限");
           return;
         }else {
           $scope.check.rectificationTime = chooseMore4.innerHTML;
         };

         if ($scope.pushNotification3.checked3) {
           if (chooseMore5.innerHTML == defaultStr) {
             $scope.showAlert("请填写违规类型");
             return;
           }else {
             $scope.check.violationType = arrayObjChild[0].id;
           };
           if (chooseMore6.innerHTML == defaultStr) {
             $scope.showAlert("请填写违规事项");
             return;
           }else {
             $scope.check.violationItem = arrayObjChild[1].id;
           };
         }
       };

       if (!$window.localstorage)
       {
         var storage=$window.localStorage;
         storage.removeItem("personLiableKey");
         storage.removeItem("personLiablIdeKey");
       }

       console.log('check',$scope.check);
       $ionicLoading.show({
         template: '提交中，请稍候...',
         noBackdrop: true
       });
       SecurityService.doCheck($scope.check).success(function(res) {
             console.log(res);
             var imgArr = $scope.imgs;
             if(imgArr.length == 0){// 没有图片
                $ionicLoading.hide();
                $timeout(function () {
                    $scope.goBack();
                }, 1000);
             }else{// 有图片
               angular.forEach(imgArr, function(data, index, array){
                 //data等价于array[index]
                 var fileURL = data;
                 if(index == imgArr.length-1){  // 是否是最后一张
                   $scope.upload(fileURL, res.entity, true);
                 }else{
                   $scope.upload(fileURL, res.entity, false);
                 }
               });
             }

           }).error(function(data) {
             $ionicLoading.hide();
             $scope.showAlert(data);
           });

   };
   $scope.onAddPic = function () {

     $ionicActionSheet.show({
       buttons: [
         {text: '立即拍摄'},
         {text: '从相册中选择'}
       ],
       titleText: '请选择图片来源',
       cancelText: '返回',
       cancel: function () {
         $log.log('cancel');
       },
       buttonClicked: function (index) {
         switch (index) {
           case 0:
             $scope.onTakePhoto();  // 调用照相功能
             break;
           case 1:
             $scope.onAddFromAlbum();  // 调用选择图片功能
             break;
           default:
             break;
         }
         return true;
       }
     });
   };



   $scope.onAddFromAlbum = function () {
     var options = {
        maximumImagesCount: 9, //需要显示的图片的数量
        width: 800,
        height: 800,
        quality: 100
       };
     	$cordovaImagePicker.getPictures(options)
         .then(function (results) {
           if(Array.isArray(results)) {
             for (var i = 0; i < results.length; i++) {
               $scope.imgs.push(results[i]);
             }
             $scope.$apply();
           }
         }, function(error) {
           // error getting photos
         });

   };
   // 照相功能
   $scope.onTakePhoto = function () {
     var options = {
       quality: 100,
       destinationType: Camera.DestinationType.FILE_URI,
       //sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
       encodingType: Camera.EncodingType.JPEG,
       mediaType: Camera.MediaType.PICTURE,
       targetHeight: 450,
       targetWidth: 350
     };
     navigator.camera.getPicture(function (fileURL) {
         $scope.imgs.push(fileURL);
         $scope.$apply();
       },
       function () {//if error
       },
       options);
   };

   // 删除图片
   $scope.deleteImg = function (index) {
     var confirmPopup = $ionicPopup.confirm({
       title: '删除图片',
       template: '确定删除第' + (index + 1) + '张图片吗?',
       cancelText: '取消',
       okText: '确定',
       okType: 'button-assertive'
     });
     confirmPopup.then(function (res) {
       if (res) {
         $scope.imgs.splice(index, 1);
         $scope.$apply();
       } else {
         console.log('You are not sure');
       }
     });
   };
   $scope.upload = function (fileURL,entity ,final) {
     var options = new FileUploadOptions();
     options.fileKey = "file";
     options.fileName = fileURL.substring(fileURL.lastIndexOf('/') + 1);
     if(options.fileName.indexOf('?') != -1){
       options.fileName = options.fileName.substring(0,options.fileName.indexOf('?'));
     }
     options.mimeType = "image/jpeg";
     var params = {
       usertoken: Storage.get('userInfo').usertoken,
       tableId:entity.id,
       tableName: "cm_security_check",
       projectId: entity.projectId,
       checkName: entity.checkName
     };
     options.params = params;
     var ft = new FileTransfer();
     ft.upload(
       fileURL,
       encodeURI(ENV.api + "/securityCheck/doUploadPic"),
       function(){
         if (final) {//如果是最后一张
           $ionicLoading.hide();
           $timeout(function () {
            $scope.goBack();
           }, 1000);
         }
       },
       function () {//失败
         console.log("图片上传失败");
         $ionicLoading.hide();
       },
       options
     );
   };
   $scope.showAlert = function (message, title) {
     $ionicPopup.alert({
       title: title || '提示信息',
       template: message,
       okText: '确定',
       okType: 'button-assertive'
     });
   };


   $scope.pushNotification1 = { checked1: true };// 初始化开关状态
   // 开关1
   $scope.pushNotificationChange1 = function() {
     $scope.check.isPresent=$scope.pushNotification1.checked1;
     console.log($scope.check);
   };
   // 开关2
   $scope.pushNotificationChange2 = function() {
        $ionicScrollDelegate.resize();// 重新计算内容高度
        $scope.showProblem = !$scope.pushNotification2.checked2;
        $scope.check.status = $scope.pushNotification2.checked2;
        var choose123 = document.getElementById("choose_2");
         choose123.innerHTML = "请选择";

    };
    // 只刷新责任人
     $scope.$on('$ionicView.beforeEnter', function() {
         if ($scope.showProblem && !$window.localstorage) {
              var choose2 =document.getElementById("choose_2");
              var storage=$window.localStorage;
              var personLiableKey=storage.personLiableKey;
              var personLiablIdeKey=storage.personLiablIdeKey;
              if (!personLiableKey) {
                choose2.innerHTML = "请选择";
              }
              else {
                choose2.innerHTML = personLiableKey;
              }
              $scope.personLiable = personLiableKey;
              $scope.manName = personLiableKey;
              $scope.manId = personLiablIdeKey;
         };
      });

    $scope.pushNotification2 = { checked2: true };
    // 开关3
    $scope.pushNotificationChange3 = function() {
        $ionicScrollDelegate.resize();
        $scope.showProblemChild = $scope.pushNotification3.checked3;
    };
    $scope.pushNotification3 = { checked3: false };

    var calendar = new datePicker2();
    // 问题选择
    $scope.clickProblemList = function(index) {
      $scope.indexNum = index;
      $scope.isProblemChild = false;
      $scope.isjianchaType = false;
      switch (index) {
        case 0:
        SecurityService.troubleType()
        .success(function (res) {
        if(res){

          $scope.questionType=res;
        }
        }).error(function (res) {
          if (res.errorCode == '000002') {
              if(confirmPopup==null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        }
         });

        $scope.showPopupSue();
        break;
        case 1:
        $scope.questionType = [
                  { id: "1", name: '严重'},
                  { id: "2", name: '中等'},
                  { id: "3", name: '一般'}
              ];
        $scope.showPopupSue();
        break;
        case 2:
          $state.go('choosePersonLiable',{checkId:$scope.check.checkId,source:$scope.check.source,projectId:$scope.check.projectId});
        break;
        case 3:
        $timeout(function(){
          // 调试时间插件后，发现有问题，添加了些后代码，得以实现，但是注意是否会影响其他地方的使用
          calendar.init({
            'trigger': '#anquantime2',
            'type': 'date',
            'minDate':'1900-1-1',
            'maxDate':'2100-12-31',
            'onSubmit':function(){
              var choose123 =document.getElementById("choose_3");
               choose123.innerHTML = calendar.value;
               $scope.rectificationTimeLimit  = calendar.value;

            },
            /*取消时触发事件*/
            'onClose':function(){
            }
          });
        },0);
        break;
        default:
        break;
      }
    };
    // 是否违规选择
    $scope.clickProblemListLegal = function(index) {
      $scope.indexNum = index;
      $scope.isProblemChild = true;
      $scope.isjianchaType = false;
      switch (index) {
        case 0:
        SecurityService.violationTypeList()
        .success(function (res) {
        if(res){

          $scope.questionType=res;
          $scope.showPopupSue();
        }
        }).error(function (res) {
          if (res.errorCode == '000002') {
            if(confirmPopup==null){
            confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
          }
         });
        break;
        case 1:
        SecurityService.violationItmeList($scope.violationType)
        .success(function (res) {
        if(res){
          $scope.questionType=res;
          console.log(res.length);
          if(res.length>0){
            $scope.showPopupSue();
          }else{
            $scope.showAlert("请填写违规类型");
          }
        }
        }).error(function (res) {
          if (res.errorCode == '000002') {
            if(confirmPopup==null){
             confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        }
         });

        break;
        default:

      }

    };

     // 请选择
     $scope.showPopupSue = function (node) {

       // 选择问题类型
       $scope.chooseProblem = function (str,idStr) {

        var choose;
        if ($scope.isjianchaType) {
          choose =document.getElementById("123");
          arrayObjChildStype[0]["id"] = idStr;
          arrayObjChildStype[0]["name"] = str;

          console.log("id",idStr);
          console.log("name",str);
        } else {
          if (!$scope.isProblemChild) {

            choose =document.getElementById("choose_"+$scope.indexNum);
            arrayObj[$scope.indexNum]["id"] = idStr;
            arrayObj[$scope.indexNum]["name"] = str;
          }
          else {

            choose =document.getElementById("chooseChild_"+$scope.indexNum);
            arrayObjChild[$scope.indexNum]["id"] = idStr;
            arrayObjChild[$scope.indexNum]["name"] = str;
            if($scope.indexNum==0){
              $scope.violationType=arrayObjChild[0].id;
            }
          }
        }


        console.log("name",arrayObj);
        console.log("id",arrayObjChild);
        console.log("脚标",$scope.indexNum);


         choose.innerHTML = str;
         myPopupOne.close();
      }

       var myPopupOne = $ionicPopup.show({

         template: '<div class="list">' +
         '<div  ng-repeat="item in questionType">' +
         '<ion-item class="mine-item" type="item-text-wrap" style="border-width: 0px;border-bottom-width: 1px;height:50px;margin:0px;text-align:center;" ng-click="chooseProblem(item.name,item.id)">{{item.name}}</ion-item>' +
         '</div>' +
         '</div>',
         title: '请选择',
         scope: $scope,
         buttons: [
           {
             text: '<b>关闭</b>',
             type: 'button-assertive',
             onTap: function () {
               return false;
             }
           }
         ]
       });

       myPopupOne.then(function (res) {

         if (!res) {

           return false;
         } else {

           console.log('Tapped!');
           //TODO
         }
       });
     };
     $scope.clickProblemListLegalTwo = function () {
       $scope.isjianchaType = true;
       $scope.questionType = [
               { id: "2", name: '安全检查'},
               { id: "1", name: '质量检查'}
             ];
       $scope.showPopupSue();
     };

  });

  return controller;
});
