define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');
  controller.controller('TabsHomeController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal) {

  });

  controller.controller('TabsHomeMessageController', function (ENV, $http, $scope, $ionicHistory,$cordovaDevice,$log, $timeout, $interval, $filter, $state, $rootScope, $ionicPopup, $ionicModal, $ionicLoading, $cordovaBarcodeScanner, Storage,
      $base64,$ionicSideMenuDelegate,NotCompletedNumService,PersonnelService,AuthService,ProjectService) {

    $scope.todayDate = new Date();
    var confirmPopup = null;
    var usertoken =  Storage.get("userInfo").usertoken;
    $scope.userName = Storage.get("userInfo").name;
    $scope.NotCompletedNums = {};
    NotCompletedNumService.getNotCompletedNums()
      .success(function (res) {
        if (res && res.record) {
          $scope.NotCompletedNums = res.record;
        }
      }).error(function (data) {
        if (data == null) {
          $ionicLoading.show({
            template: "服务器异常，请稍后再试。",
            duration: 800
          });
        } else if (data.errorCode == '000002') {
          if(  confirmPopup==null){
            var confirmPopup =  $ionicPopup.alert({
                   title: '提示信息',
                   template: '该帐号已在其他设备登录！',
                   okText: '确定',
                   okType: 'button-assertive'
                 });
            confirmPopup.then(function(res) {
              if(res) {
                Storage.remove('isLogged');
                Storage.remove('userInfo');
                Storage.remove('menuList');
                $state.go('login');
              }
            });
          }
        } else {
          $ionicLoading.show({
            template: data.msg,
            duration: 800
          });
        }
      });


    var platform;
    if (window.device) {
      platform = $cordovaDevice.getPlatform();
    }

    $scope.menuList = Storage.get("menuList");
    // AuthService.menuList(usertoken)
    //   .success(function (res) {
    //     if (res && res.record) {
    //       $scope.menuList = res.record.menuList;
    //     }
    //   }).error(function (data) {
    //     if (data == null) {
    //       $ionicLoading.show({
    //         template: "服务器异常，请稍后再试。",
    //         duration: 800
    //       });
    //     } else if (data.errorCode == '000002') {
    //       Storage.remove('isLogged');
    //       Storage.remove('userInfo');
    //       $state.go('login')
    //     } else {
    //       $ionicLoading.show({
    //         template: data.msg,
    //         duration: 800
    //       });
    //     }
    //   });

      $scope.staffNums = 0;
      // PersonnelService.staffList(0, -1,usertoken)
      // .success(function (res) {
      // if(res){
      //   $scope.staffNums = res.userList.length;
      // }
      // }).error(function (res) {
      //   if (res.errorCode == '000002') {
      //
      //       if(confirmPopup == null){
      //      confirmPopup =  $ionicPopup.alert({
      //            title: '提示信息',
      //            template: '该帐号已在其他设备登录！',
      //            okText: '确定',
      //            okType: 'button-assertive'
      //          });
      //        }
      //     confirmPopup.then(function(res) {
      //       if(res) {
      //         Storage.remove('isLogged');
      //         Storage.remove('userInfo');
      //         Storage.remove('menuList');
      //         $state.go('login');
      //       }
      //     });
      //   }
      //  });


    //通讯录改版
    $scope.showMailGParent = function(){
      $state.go('mailListGParent');

    };

    //项目列表改版
    $scope.goProject = function(){
          ProjectService.isOrg(usertoken)
          .success(function (res) {
            // if (res.isOrg) {
            //   $state.go('pja');
            // }else{
            //   $state.go('pjdetails',{title:"项目列表"});
            // }
            $state.go('pja');
          });
    };

    $scope.toggleLeft = function() {
  	    $ionicSideMenuDelegate.toggleLeft();
  	};

    // $scope.showMailList = function () {
    //   $state.go('mailList');
    // };
    $scope.showNewPassword = function () {
      $state.go('newPassword');
    };

    $scope.showLogoutPop = function () {
        $scope.showState = false;
        if (platform === 'iOS') {
          $scope.showState = true;
        }
        // $scope.logoutPop = $ionicPopup.show({
        //   templateUrl: 'modules/portal/templates/mine/logout_pop.html',
        //   title: '退出确定',
        //   scope: $scope
        // });

        $ionicPopup.confirm({
          title: '提示信息',
          template: '确定注销登录？',
          cssClass: 'hi-pop-width',
          buttons: [{ //Array[Object] (可选)。放在弹窗footer内的按钮。
           text: '取消',
           type: 'button-default',
           onTap: function(e) {
             // 当点击时，e.preventDefault() 会阻止弹窗关闭。

           }
         },{
             text: '确认',
             type: 'button-assertive',
             onTap: function(e) {
               Storage.remove('isLogged');
               Storage.remove('userInfo');
               Storage.remove('menuList');
               $state.go('login');
             }
           }]
        });
      };

      $scope.closeApp = function () {
        $scope.logoutPop.close();
        ionic.Platform.exitApp();
      };

      $scope.logout = function () {
        $scope.logoutPop.close();
        Storage.remove('isLogged');
        Storage.remove('userInfo');
        Storage.remove('menuList');
        $state.go('login');
      };
  });

  controller.controller('TaskArrangementController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal) {

  });

  return controller;
});
