define(['portal.boot'], function (require) {
  'use strict';

  var controller = angular.module('portal.controllers');
  controller.controller('TabsMineController', function (ENV, Storage, $ionicPlatform, $ionicModal, $scope, $state, $cordovaAppVersion, $ionicActionSheet, $ionicPopup, $stateParams, $cordovaDevice, $ionicLoading) {


    var platform;
    if (window.device) {
      platform = $cordovaDevice.getPlatform();
    }
    $scope.showLogoutPop = function () {
      $scope.showState = false;
      if (platform === 'iOS') {
        $scope.showState = true;
      }
      $scope.logoutPop = $ionicPopup.show({
        templateUrl: 'modules/portal/templates/mine/logout_pop.html',
        title: '退出确定',
        scope: $scope
      });
    };

    $scope.closeApp = function () {
      $scope.logoutPop.close();
      ionic.Platform.exitApp();
    };

    $scope.logout = function () {
      $scope.logoutPop.close();
      Storage.removeItem('isLogged');
      Storage.removeItem('userInfo');
      Storage.removeItem('menuList');
      $state.go('tabs.home.message');
    };

  });

  return controller;
});
