define(['projectDynamics.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectDynamics.controllers');

  controller.controller('ProjectDynamicsacDetailsController', function (ENV,$window, $scope,$ionicScrollDelegate, $log, $timeout, $rootScope, $ionicPopup, $state, $stateParams,$ionicHistory, $ionicLoading,$interval, Storage, AuthService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.titleTxt =  $stateParams.title;
    $scope.qaq = false;
    $scope.showNull = false;

    // proDDKey数据存储
    if (!$window.localstorage) {
      var storage=$window.localStorage;
      var proDDKey=storage.proDDKey
      if (proDDKey) {
        $scope.titleTxt=proDDKey;
      }
      else {
        storage["proDDKey"]=$scope.titleTxt;
      }
    }

    $scope.bigImage = false;
    $scope.hideBigImage = function () {

      $scope.bigImage = false;
    };

    //点击图片放大
    $scope.shouBigImage = function (imageName) {
      var arr = [];
      var o = {};
      o.picUrl = imageName;
      arr.push(o);
      PicturePreview.picturePreview(arr, 0, '', function (success) {
        }, function (error) {
        }
      );
    };
    //
    // $scope.shouBigImage = function (imageName) {  //传递一个参数（图片的URl）
    //   $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    //   console.log(  $scope.Url);
    //   $scope.bigImage = true;   //显示大图
    // };
   var scroll;
   $scope.clickListqaq = function () {

     scroll = document.getElementById("qaqid").offsetTop - $ionicScrollDelegate.getScrollPosition().top;
     $ionicScrollDelegate.scrollBy(0,scroll,true);
     $ionicScrollDelegate.resize();// 页面逻辑处理完后，才能进行高度重新计算
      $scope.qaq =  !$scope.qaq;
      scroll = null;
   };

    $scope.itemsLunbo = [
              { id: 0, name: '霍强', address: '重庆市曾家岩轻轨站出口FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 1, name: '姜舟', address: '重庆市求精中学校门口FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 2, name: '吴秀其', address: '重庆市渝中区牛角沱FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 3, name: '文明亮', address: '重庆市南岸区鼎维FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' }
          ];

    $scope.items = [
              { id: 0, name: '霍强', phone: '18923456633', src: 'modules/personManage/img//person1.png'}
          ];
    $scope.itemsContent = [
              { id: 0, name: '霍强', des: "噢噢噢噢噢噢", time: "2017-06-09 10:39"},
              { id: 1, name: '霍强', des: "噢噢噢噢噢噢", time: "2017-06-09 10:39"},
              { id: 2, name: '霍强', des: "噢噢噢噢噢噢", time: "2017-06-09 10:39"}
          ];

    $scope.asdasdasd = function () {
      alert("asd");
    };

  });

  return controller;
});
