/**
 * @Author:      LufeiBoy
 * @DateTime:    null
 * @Description: 项目列表的controller
 * @Last Modified By:   LufeiBoy
 * @Last Modified Time:    null
 */
define(['projectList.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectList.controllers');

  controller.controller('ProjectListController', function (ENV,$window, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, $stateParams,Storage, ProjectService, TaskService) {

    $scope.goBack = function() {
        if($scope.title == "组织列表"||  $scope.ename=="O_ROOT"){
          $state.go('tabs.home.message');
        }else {
          var index = $scope.ename .lastIndexOf("\_");
          $scope.ename  = $scope.ename.substring(0, index);
          $scope.datalist=[];
          $scope.title = $scope.oldTitle;
          $scope.loadMore();
        }
    };

    var confirmPopup = null;
    $scope.datalist=[];
    $scope.showNull=true;
    $scope.title = "组织列表"
    $scope.ename="O_ROOT";
    var usertoken =  Storage.get("userInfo").usertoken;
      $scope.loadMore = function () {
        $ionicLoading.show({
          template: '加载中，请稍候...',
          noBackdrop: true
        });
          ProjectService.getOrg(usertoken,$scope.ename)
          .success(function (res) {
          if(res&&res.list.length>0){
                $scope.datalist = $scope.datalist.concat(res.list);
                $scope.showNull=false;
            }
               $ionicLoading.hide();
          }).error(function (res) {
            if (res.errorCode == '000002') {
              if(confirmPopup == null){
               confirmPopup =  $ionicPopup.alert({
                     title: '提示信息',
                     template: '该帐号已在其他设备登录！',
                     okText: '确定',
                     okType: 'button-assertive'
                   });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            }
            }
               $ionicLoading.hide();
           });
      };
      $scope.loadMore();
     $scope.next = function (leafNode,ename,cname,index,id) {
         if(leafNode==1&&index>0){
           $scope.datalist=[];
           $scope.ename=ename;
           $scope.oldTitle = $scope.title;
           $scope.title=cname;
           $scope.loadMore();
         }else{
            $state.go('pjdetails',{id:id,title:cname});
         }
     };
  });

  return controller;
});
