define(['projectList.boot'], function (require) {
  'use strict';

  var controller = angular.module('projectList.controllers');

  controller.controller('ProjectListSubkeyDetailsController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $stateParams,$ionicHistory, $ionicLoading,$interval, Storage, AuthService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.titleTxt =  $stateParams.name;
     $scope.showNull = false;

    $scope.bigImage = false;
    $scope.hideBigImage = function () {

      $scope.bigImage = false;
    };

    // //点击图片放大
    // $scope.shouBigImage = function (imageName) {  //传递一个参数（图片的URl）
    //   $scope.Url = imageName;                   //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    //   console.log(  $scope.Url);
    //   $scope.bigImage = true;                   //显示大图
    // };

    $scope.shouBigImage = function (imageName) {
      var arr = [];
      var o = {};
      o.picUrl = imageName;
      arr.push(o);
      PicturePreview.picturePreview(arr, 0, '', function (success) {
        }, function (error) {
        }
      );
    };

    $scope.itemsLunbo = [
              { id: 0, name: '霍强', address: '重庆市曾家岩轻轨站出口FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 1, name: '姜舟', address: '重庆市求精中学校门口FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 2, name: '吴秀其', address: '重庆市渝中区牛角沱FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' },
              { id: 3, name: '文明亮', address: '重庆市南岸区鼎维FRRU_上清寺某某街道多少号', src: 'modules/personManage/img/person1.png' }
          ];

    $scope.items = [
              { id: 0, name: '霍强', phone: '18923456633', src: 'modules/personManage/img//person1.png' },
              { id: 1, name: '姜舟', phone: '18344565656', src: 'modules/personManage/img/person1.png' },
              { id: 2, name: '吴秀其', phone: '18923445743', src: 'modules/personManage/img/person1.png' },
              { id: 3, name: '文明亮', phone: '18923467894', src: 'modules/personManage/img/person1.png' },
              { id: 4, name: '唐建宇', phone: '18923456230', src: 'modules/personManage/img/person1.png' },
              { id: 5, name: '文明亮', phone: '18923467894', src: 'modules/personManage/img/person1.png' },
              { id: 6, name: '文明亮', phone: '18923467894', src: 'modules/personManage/img/person1.png' }
          ];
  });

  return controller;
});
