define(function (require) {
    'use strict';

    var routes = angular.module("riskWarning.route", []);

    routes.config(function ($stateProvider, $urlRouterProvider) {
      $stateProvider
      //主路径 风险提示
      .state('riskWarning', {
        url: '/riskWarning/:projectTaskId/:type',
        cache:false,
        templateUrl: 'modules/riskWarning/templates/riskWarning.html',
        controller: "RiskWarningController"
      })

      .state('riskWarningDetails', {
        url: '/riskWarningDetails/:name',
        cache:false,
        templateUrl: 'modules/riskWarning/templates/RiskWarningDetails.html',
        controller: "RiskWarningDetailsController"
      })

    });

    return routes;
});
