define(['safetyCheckRecord.boot'], function (require) {
  'use strict';

  var controller = angular.module('safetyCheckRecord.controllers');

  controller.controller('SafetyCheckRecordListController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$stateParams, Storage, SafetyCheckRecordService) {

    $scope.History = {
      goBack: function () {
        $ionicHistory.goBack();
      }
    };
    $scope.onPullDown = function () {
      getData()
    };

    function getData() {
      var usertoken =  Storage.get("userInfo").usertoken;
      console.log(usertoken);
      SafetyCheckRecordService.getCheckRecordNum(usertoken)
        .success(function (res) {
          if(res){

            $scope.dnum = res.dnum

            $scope.dnum1= res.dnum1

            $scope.dnum2= res.dnum2

            $scope.pnum= res.pnum

            $scope.pnum1= res.pnum1

            $scope.pnum2= res.pnum2

            $scope.spnum= res.spnum

            $scope.spnum1= res.spnum1

            $scope.spnum2= res.spnum2

            $scope.tnum= res.tnum

            $scope.tnum1= res.tnum1

            $scope.tnum2= res.tnum2

          }
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }).error(function (res) {
        if (res.errorCode == '000002') {
          var confirmPopup =  $ionicPopup.alert({
            title: '提示信息',
            template: '该帐号已在其他设备登录！',
            okText: '确定',
            okType: 'button-assertive'
          });
          confirmPopup.then(function(res) {
            if(res) {
              Storage.remove('isLogged');
              Storage.remove('userInfo');
              Storage.remove('menuList');
              $state.go('login');
            }
          });
        }
      });
    }
    getData();
  });

  return controller;
});
