define(function (require) {
    'use strict';

    var routes = angular.module("safetyCheckRecord.route", []);

    routes.config(function ($stateProvider, $urlRouterProvider) {
      $stateProvider

      //主路径 安质检查记录
      .state('safetyCheckRecord', {
        url: '/safetyCheckRecord/:isSolve/:source/:checkType',
        templateUrl: 'modules/safetyCheckRecord/templates/safetyCheckRecord.html',
        controller: "SafetyCheckRecordController"
      })

      //安质检查记录详情
      .state('safetyCheckRecordDetails', {
        url: '/safetyCheckRecordDetails/:checkId/:source',
        templateUrl: 'modules/safetyCheckRecord/templates/safetyCheckRecordDetails.html',
        controller: "SafetyCheckRecordDetailsController"
      })

      //安质检查详情
      .state('checkDetails', {
        url: '/checkDetails/:id/:source',
        cache: false,
        templateUrl: 'modules/safetyCheckRecord/templates/checkDetails.html',
        controller: "CheckDetailsController"
      })
      //安质检查详情
      .state('checkList', {
        url: '/checkList',
        templateUrl: 'modules/safetyCheckRecord/templates/SafetyCheckRecordList.html',
        controller: "SafetyCheckRecordListController"
      })
      //安质检查跟进
      .state('scFollowUp', {
        url: '/scFollowUp/:id',
        templateUrl: 'modules/safetyCheckRecord/templates/followUp.html',
        controller: "SCFollowUpController"
      })



    });

    return routes;
});
