/*
* @Author: HuangTiger
* @Date:   2017-06-09 11:10:44
* @Last Modified by:   HuangTiger
* @Last Modified time: 2017-07-21 10:57:10
*/

define(['todaytask.boot'], function (require) {
  'use strict';

  var controller = angular.module('todaytask.controllers', ['ion-tree-list']);

  //站点任务
  controller.controller('TodayTaskIndexController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal,$state,TodayTaskService,LocalDragon,Storage,$cordovaKeyboard,$ionicScrollDelegate) {

    $scope.goHref = function(){
      //$scope.clearCache();
      $state.go('tabs.home.message');
    };

    $scope.status = null;
    $scope.type = null;
  	/*测试数据*/
  	//$scope.projects = [];
    $scope.showNull = false;

    $scope.datalist = [];
    $scope.start = 0;
    $scope.limit = 15;
    $scope.condition = {
      condition1:""
    };
    $scope.loadMore = function () {
      TodayTaskService.getSubProjectTree($scope.start, $scope.limit, $scope.status,$scope.type,null,$scope.condition.condition1)
          .success(function (res) {
            // console.log('res:', res);
            if (res ) {
              //有数据
              $scope.showNull = false;

              var records = res.record;
              $scope.start = $scope.start + records.length;
              $scope.datalist = $scope.datalist.concat(records);

                console.log(records);
              //变相控制列表点击是否展示内容

              if (records.length >= $scope.limit) {
                console.log(123);
                $scope.hasMore = true;
              } else {
                  console.log(321);
                $scope.hasMore = false;
              }
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            if($scope.datalist.length == 0){
              $scope.showNull = true;
            }
          }).error(function (data) {

            //无数据
            if($scope.datalist.length == 0){
              $scope.showNull = true;
            }
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });
    };
    $scope.loadMore();

    $scope.keyboard = {show: false};
    $scope.todoSomething=function($event){
      if($event.keyCode==13){//回车
        $scope.startDot();
      }
    };
    $scope.startDot = function() {//判断清除输入框的图标是否显示
      if($scope.condition.condition1.length==0 || $scope.condition.condition1=="") {
        $scope.searchEmptyShow=false;
      }else{
        $scope.searchEmptyShow=true;
      }
      $scope.start = 0;
      $scope.datalist = [];
      $scope.loadMore();
      $cordovaKeyboard.close();
      $ionicScrollDelegate.scrollTop();
    };

    //$scope.getSubProjectTree = function(){
    //  $ionicLoading.show({
    //    template: '加载中，请稍候...',
    //    noBackdrop: true
    //  });
    //  $scope.projects = [];
    //  TodayTaskService.getSubProjectTree($scope.status,$scope.type)
    //    .success(function (data) {
    //      $ionicLoading.hide();
    //      if (data.record.length !== 0) {
    //        //有数据
    //        $scope.showNull = false;
    //        for (var i = 0; i < data.record.length; i++) {
    //          var project = data.record[i];
    //          var name = project.projectName;
    //          var tree = [];
    //          for (var j = 0; j < data.record[i].projectSubList.length; j++) {
    //            var subProject = data.record[i].projectSubList[j];
    //            var subInfo = {id : subProject.projectSubId, name : subProject.projectSubName, projectId : project.projectId ,url : 'performTask.taskList', depth : 2, collapsed: true}
    //            tree.push(subInfo);
    //            tree['collapsed'] = true;
    //          }
    //          $scope.projects.push({name : name, tree : tree, depth : 1});
    //        }
    //      }else{
    //        //无数据
    //        $scope.showNull = true;
    //      }
    //    }).error(function (data) {
    //      $ionicLoading.hide();
    //      //无数据
    //      $scope.showNull = true;
    //
    //      if(data == null){
    //        $ionicLoading.show({
    //          template: "服务器异常，请稍后再试。",
    //          duration: 800
    //        });
    //      } else if (data.errorCode == '000002') {
    //        var confirmPopup =  $ionicPopup.alert({
    //          title: '提示信息',
    //          template: '该帐号已在其他设备登录！',
    //          okText: '确定',
    //          okType: 'button-assertive'
    //        });
    //        confirmPopup.then(function(res) {
    //          if(res) {
    //            Storage.remove('isLogged');
    //            Storage.remove('userInfo');
    //            Storage.remove('menuList');
    //            $state.go('login');
    //          }
    //        });
    //      } else {
    //        $ionicLoading.show({
    //          template: data.msg,
    //          duration: 800
    //        });
    //      }
    //    });
    //};
    //
  	////🌲的2次触碰
    //$scope.$on('$ionTreeList:ItemClicked', function(event, item) {
    //  // 捕捉到你点击的那个元素
    //  if (item.url) {
    //    $state.go(item.url,{projectId:item.projectId,projectSubId:item.id,status:$scope.status,type:$scope.type});
    //  }
    //});

  	//$scope.choiceType = function(str){
      //$scope.type = str;
  	//};
      //
  	//$scope.choicePState = function(str){
      //$scope.status = str;
  	//};

    //$scope.recordCache = function(){
    //  LocalDragon.set("todayTask_status",$scope.status);
    //  LocalDragon.set("todayTask_type",$scope.type);
    //};
    //$scope.clearCache = function(){
    //  LocalDragon.removeItem("todayTask_status");
    //  LocalDragon.removeItem("todayTask_type");
    //};
    //$scope.initCache = function(){
    //  $scope.status = getCatchValue(LocalDragon.get("todayTask_status"));
    //  $scope.type = getCatchValue(LocalDragon.get("todayTask_type"));
    //};
    //function getCatchValue(obj){
    //  if(obj && obj != null && obj != "null"){
    //    return obj
    //  }else{
    //    return null;
    //  }
    //}
    //$scope.initCache();
    //$scope.getSubProjectTree();
  	//$scope.showPopupIndex = function (node) {
      //
  	//	var myPopupOne = $ionicPopup.show({
      //
	  //      template: '<div class="list">' +
      //
	  //      '<div class="item mine-item">' +
	  //      '<div>任务类型</div>' +
	  //      '<div >' +
       //   '<span class="re-select margin-right" ng-class="{\'selectNode\':type==null}" ng-click="choiceType(null)">全部</span>' +
	  //      '<span class="re-select margin-right" ng-class="{\'selectNode\':type==2}" ng-click="choiceType(2)">关键</span>' +
	  //      '<span class="re-select" ng-class="{\'selectNode\':type==1}" ng-click="choiceType(1)">普通</span></div>' +
	  //      '</div>' +
      //
	  //      '<div class="item mine-item">' +
	  //      '<div>任务状态</div>' +
	  //      '<div >' +
       //   '<span class="re-select margin-right" ng-class="{\'selectNode\':status==null}" ng-click="choicePState(null)">全部</span>' +
	  //      '<span class="re-select margin-right" ng-class="{\'selectNode\':status==4}" ng-click="choicePState(4)">已完成</span>' +
	  //      '<span class="re-select" ng-class="{\'selectNode\':status==1}" ng-click="choicePState(1)">未完成</span></div>' +
	  //      '</div>' +
      //
	  //      '</div>',
	  //      title: '任务筛选',
	  //      scope: $scope,
	  //      buttons: [
	  //        {
	  //          text: '取消',
	  //          onTap: function () {
       //         $scope.initCache();
	  //            return false;
	  //          }
	  //        },
	  //        {
	  //          text: '<b>确定</b>',
	  //          type: 'button-positive',
	  //          onTap: function (e) {
       //         $scope.recordCache();
       //         $scope.getSubProjectTree();
	  //            return false;
	  //          }
	  //        }
       // ]
      //});
      //
      //myPopupOne.then(function (res) {
      //
       // if (!res) {
      //
       //   return false;
       // } else {
      //
       //   console.log('Tapped!');
       //   //TODO
      //
       // }
      //
      //});
  	//};

  });

  controller.controller('TodayTaskIndexController1', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal,$state,TodayTaskService,LocalDragon,Storage,$ionicHistory,$stateParams,$cordovaKeyboard,$ionicScrollDelegate) {

    $scope.goHref = function(){
      //$scope.clearCache();
      $ionicHistory.goBack();
    };
    $scope.projectId = $stateParams.projectId;
    $scope.status = null;
    $scope.type = null;
    /*测试数据*/
    //$scope.projects = [];
    $scope.showNull = false;

    $scope.datalist = [];
    $scope.start = 0;
    $scope.limit = 15;
    $scope.condition = {
        condition1:""
    };
    $scope.loadMore = function () {
      TodayTaskService.getSubProjectTree($scope.start, $scope.limit, $scope.status,$scope.type,$scope.projectId,$scope.condition.condition1)
          .success(function (res) {
            // console.log('res:', res);
            if (res) {
              //有数据
              $scope.showNull = false;

              var records = res.record;
              $scope.start = $scope.start + records.length;
              $scope.datalist = $scope.datalist.concat(records);

              // console.log('$scope.datalist:', $scope.datalist);

              //变相控制列表点击是否展示内容

              if (records.length >= $scope.limit) {
                $scope.hasMore = true;
              } else {
                $scope.hasMore = false;
              }
              $scope.$broadcast('scroll.infiniteScrollComplete');
            }
            if($scope.datalist.length == 0){
              $scope.showNull = true;
            }
          }).error(function (data) {
            //无数据
            if($scope.datalist.length == 0){
              $scope.showNull = true;
            }
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });
    };
    $scope.loadMore();
    $scope.keyboard = {show: false};
    $scope.todoSomething=function($event){
      if($event.keyCode==13){//回车
        $scope.startDot();
      }
    };
    $scope.startDot = function() {//判断清除输入框的图标是否显示
      if($scope.condition.condition1.length==0 || $scope.condition.condition1=="") {
        $scope.searchEmptyShow=false;
      }else{
        $scope.searchEmptyShow=true;
      }
      $scope.start = 0;
      $scope.datalist = [];
      $scope.loadMore();
      $cordovaKeyboard.close();
      $ionicScrollDelegate.scrollTop();
    };
    //$scope.getSubProjectTree = function(){
    //  $ionicLoading.show({
    //    template: '加载中，请稍候...',
    //    noBackdrop: true
    //  });
    //  $scope.projects = [];
    //  TodayTaskService.getSubProjectTree($scope.status,$scope.type)
    //    .success(function (data) {
    //      $ionicLoading.hide();
    //      if (data.record.length !== 0) {
    //        //有数据
    //        $scope.showNull = false;
    //        for (var i = 0; i < data.record.length; i++) {
    //          var project = data.record[i];
    //          var name = project.projectName;
    //          var tree = [];
    //          for (var j = 0; j < data.record[i].projectSubList.length; j++) {
    //            var subProject = data.record[i].projectSubList[j];
    //            var subInfo = {id : subProject.projectSubId, name : subProject.projectSubName, projectId : project.projectId ,url : 'performTask.taskList', depth : 2, collapsed: true}
    //            tree.push(subInfo);
    //            tree['collapsed'] = true;
    //          }
    //          $scope.projects.push({name : name, tree : tree, depth : 1});
    //        }
    //      }else{
    //        //无数据
    //        $scope.showNull = true;
    //      }
    //    }).error(function (data) {
    //      $ionicLoading.hide();
    //      //无数据
    //      $scope.showNull = true;
    //
    //      if(data == null){
    //        $ionicLoading.show({
    //          template: "服务器异常，请稍后再试。",
    //          duration: 800
    //        });
    //      } else if (data.errorCode == '000002') {
    //        var confirmPopup =  $ionicPopup.alert({
    //          title: '提示信息',
    //          template: '该帐号已在其他设备登录！',
    //          okText: '确定',
    //          okType: 'button-assertive'
    //        });
    //        confirmPopup.then(function(res) {
    //          if(res) {
    //            Storage.remove('isLogged');
    //            Storage.remove('userInfo');
    //            Storage.remove('menuList');
    //            $state.go('login');
    //          }
    //        });
    //      } else {
    //        $ionicLoading.show({
    //          template: data.msg,
    //          duration: 800
    //        });
    //      }
    //    });
    //};
    //
    ////🌲的2次触碰
    //$scope.$on('$ionTreeList:ItemClicked', function(event, item) {
    //  // 捕捉到你点击的那个元素
    //  if (item.url) {
    //    $state.go(item.url,{projectId:item.projectId,projectSubId:item.id,status:$scope.status,type:$scope.type});
    //  }
    //});

    //$scope.choiceType = function(str){
    //$scope.type = str;
    //};
    //
    //$scope.choicePState = function(str){
    //$scope.status = str;
    //};

    //$scope.recordCache = function(){
    //  LocalDragon.set("todayTask_status",$scope.status);
    //  LocalDragon.set("todayTask_type",$scope.type);
    //};
    //$scope.clearCache = function(){
    //  LocalDragon.removeItem("todayTask_status");
    //  LocalDragon.removeItem("todayTask_type");
    //};
    //$scope.initCache = function(){
    //  $scope.status = getCatchValue(LocalDragon.get("todayTask_status"));
    //  $scope.type = getCatchValue(LocalDragon.get("todayTask_type"));
    //};
    //function getCatchValue(obj){
    //  if(obj && obj != null && obj != "null"){
    //    return obj
    //  }else{
    //    return null;
    //  }
    //}
    //$scope.initCache();
    //$scope.getSubProjectTree();
    //$scope.showPopupIndex = function (node) {
    //
    //	var myPopupOne = $ionicPopup.show({
    //
    //      template: '<div class="list">' +
    //
    //      '<div class="item mine-item">' +
    //      '<div>任务类型</div>' +
    //      '<div >' +
    //   '<span class="re-select margin-right" ng-class="{\'selectNode\':type==null}" ng-click="choiceType(null)">全部</span>' +
    //      '<span class="re-select margin-right" ng-class="{\'selectNode\':type==2}" ng-click="choiceType(2)">关键</span>' +
    //      '<span class="re-select" ng-class="{\'selectNode\':type==1}" ng-click="choiceType(1)">普通</span></div>' +
    //      '</div>' +
    //
    //      '<div class="item mine-item">' +
    //      '<div>任务状态</div>' +
    //      '<div >' +
    //   '<span class="re-select margin-right" ng-class="{\'selectNode\':status==null}" ng-click="choicePState(null)">全部</span>' +
    //      '<span class="re-select margin-right" ng-class="{\'selectNode\':status==4}" ng-click="choicePState(4)">已完成</span>' +
    //      '<span class="re-select" ng-class="{\'selectNode\':status==1}" ng-click="choicePState(1)">未完成</span></div>' +
    //      '</div>' +
    //
    //      '</div>',
    //      title: '任务筛选',
    //      scope: $scope,
    //      buttons: [
    //        {
    //          text: '取消',
    //          onTap: function () {
    //         $scope.initCache();
    //            return false;
    //          }
    //        },
    //        {
    //          text: '<b>确定</b>',
    //          type: 'button-positive',
    //          onTap: function (e) {
    //         $scope.recordCache();
    //         $scope.getSubProjectTree();
    //            return false;
    //          }
    //        }
    // ]
    //});
    //
    //myPopupOne.then(function (res) {
    //
    // if (!res) {
    //
    //   return false;
    // } else {
    //
    //   console.log('Tapped!');
    //   //TODO
    //
    // }
    //
    //});
    //};

  });

  //项目任务
  controller.controller('TodayTaskTaskController', function (ENV, $scope, $cordovaDatePicker, $log, $timeout, $rootScope, $ionicPopup, $ionicLoading, $ionicModal,$state,TodayTaskService,LocalDragon,Storage,$cordovaKeyboard,$ionicScrollDelegate) {
    $scope.goHref = function(){
      //$scope.clearCache();
      $state.go('tabs.home.message');
    };
    $scope.status = null;
    $scope.type = null;
    $scope.showNull = false;
  	/*测试数据*/
    $scope.datalist = [];
    $scope.start = 0;
    $scope.limit = 15;
    $scope.condition = {
        condition1:""
    };

    $scope.loadMore = function () {
      TodayTaskService.getProject($scope.status,$scope.type,$scope.start,$scope.limit,$scope.condition.condition1)
          .success(function (res) {
            // console.log('res:', res);
            if (res) {
              //有数据

              var records = res.record;
              $scope.start = $scope.start + records.length;
              $scope.datalist = $scope.datalist.concat(records);

              // console.log('$scope.datalist:', $scope.datalist);

              //变相控制列表点击是否展示内容

              if (records.length >= $scope.limit) {
                $scope.hasMore = true;
              } else {
                $scope.hasMore = false;
              }
            }
            if($scope.datalist.length  == 0){
              $scope.showNull = true;
            }else {
              $scope.showNull = false;
            }
            $scope.$broadcast('scroll.infiniteScrollComplete');
          }).error(function (data) {
            //无数据
            if($scope.datalist.length == 0){
              $scope.showNull = true;
            }
            if (data == null) {
              $ionicLoading.show({
                template: "服务器异常，请稍后再试。",
                duration: 800
              });
            } else if (data.errorCode == '000002') {
              var confirmPopup =  $ionicPopup.alert({
                title: '提示信息',
                template: '该帐号已在其他设备登录！',
                okText: '确定',
                okType: 'button-assertive'
              });
              confirmPopup.then(function(res) {
                if(res) {
                  Storage.remove('isLogged');
                  Storage.remove('userInfo');
                  Storage.remove('menuList');
                  $state.go('login');
                }
              });
            } else {
              $ionicLoading.show({
                template: data.msg,
                duration: 800
              });
            }
          });
    };
    $scope.loadMore();

    $scope.keyboard = {show: false};
    $scope.todoSomething=function($event){
      if($event.keyCode==13){//回车
        $scope.startDot();
      }
    };
    $scope.startDot = function() {//判断清除输入框的图标是否显示
      if($scope.condition.condition1.length==0 || $scope.condition.condition1=="") {
        $scope.searchEmptyShow=false;
      }else{
        $scope.searchEmptyShow=true;
      }
      $scope.start = 0;
      $scope.datalist = [];
      $scope.loadMore();
      $cordovaKeyboard.close();
      $ionicScrollDelegate.scrollTop();
    };
  	/*子项筛选框*/
    //$scope.choiceType = function(str){
    //  $scope.type = str;
    //};
    //
    //$scope.choicePState = function(str){
    //  $scope.status = str;
    //};

    //$scope.recordCache = function(){
    //  LocalDragon.set("todayTask_status",$scope.status);
    //  LocalDragon.set("todayTask_type",$scope.type);
    //};
    //$scope.clearCache = function(){
    //  LocalDragon.removeItem("todayTask_status");
    //  LocalDragon.removeItem("todayTask_type");
    //};
    //$scope.initCache = function(){
    //  $scope.status = getCatchValue(LocalDragon.get("todayTask_status"));
    //  $scope.type = getCatchValue(LocalDragon.get("todayTask_type"));
    //};
    //function getCatchValue(obj){
    //  if(obj && obj != null && obj != "null"){
    //    return obj
    //  }else{
    //    return null;
    //  }
    //}
    //$scope.initCache();
    //$scope.getProject();
      //$scope.showPopupTask = function (node) {
      //
  		//var myPopupOne = $ionicPopup.show({
      //
      //  template: '<div class="list">' +
      //
      //  '<div class="item mine-item">' +
      //  '<div>任务类型</div>' +
      //  '<div >' +
      //  '<span class="re-select margin-right" ng-class="{\'selectNode\':type==null}" ng-click="choiceType(null)">全部</span>' +
      //  '<span class="re-select margin-right" ng-class="{\'selectNode\':type==2}" ng-click="choiceType(2)">关键</span>' +
      //  '<span class="re-select" ng-class="{\'selectNode\':type==1}" ng-click="choiceType(1)">普通</span></div>' +
      //  '</div>' +
      //
      //  '<div class="item mine-item">' +
      //  '<div>任务状态</div>' +
      //  '<div >' +
      //  '<span class="re-select margin-right" ng-class="{\'selectNode\':status==null}" ng-click="choicePState(null)">全部</span>' +
      //  '<span class="re-select margin-right" ng-class="{\'selectNode\':status==4}" ng-click="choicePState(4)">已完成</span>' +
      //  '<span class="re-select" ng-class="{\'selectNode\':status==1}" ng-click="choicePState(1)">未完成</span></div>' +
      //  '</div>' +
      //
      //  '</div>',
	   //     title: '任务筛选',
	   //     scope: $scope,
	   //     buttons: [
	   //       {
	   //         text: '取消',
	   //         onTap: function () {
      //          $scope.initCache();
	   //           return false;
	   //         }
	   //       },
	   //       {
	   //         text: '<b>确定</b>',
	   //         type: 'button-positive',
	   //         onTap: function (e) {
      //          $scope.recordCache();
      //          $scope.getProject();
      //          return false;
	   //         }
	   //       }
      //  ]
      //});
      //
      //myPopupOne.then(function (res) {
      //
      //  if (!res) {
      //
      //    return false;
      //  } else {
      //
      //    console.log('Tapped!');
      //    //TODO
      //
      //  }
      //
      //});
      //};

  });

  return controller;

});
