define(['workloadReporting.boot'], function (require) {
  'use strict';

  var controller = angular.module('workloadReporting.controllers',['ion-tree-list-Other-styles']);

  controller.controller('WorkloadReportingController', function (ENV, $scope, $log, $timeout, $rootScope, $ionicPopup, $state, $ionicHistory, $ionicLoading,$interval,$ionicScrollDelegate, Storage, PersonnelService) {

     $scope.showNull = false;

    /*测试数据*/
  	$scope.projects = [
  		{
  			name : '车车1',
  			tree : [
  				{
            id : 1,
  					name : '车你二三爸',
            tree : [
              {
                id : 2,
                name : '车你三爸',
                state : true,
                stateNum : 1,
                url : 'workloadReportingDetails'
              },
              {
                id : 3,
                name : '车你二爸',
                state : true,
                stateNum : 2,
                url : 'workloadReportingDetails'
              }
            ],
  				},
  				{
            id : 4,
  					name : '车你一二爸',
            tree : [
              {
                id : 5,
                name : '车你一爸',
                state : true,
                stateNum : 3,
                url : 'workloadReportingDetails'
              },
              {
                id : 6,
                name : '车你二爸',
                state : true,
                stateNum : 2,
                url : 'workloadReportingDetails'
              }
            ],
  				}
  			]
  		},
      {
        id : 7,
        name : '车车2',
        tree : [
          {
            id : 8,
            name : '车你五爸',
            state : true,
            stateNum : 3,
            url : 'workloadReportingDetails'
          },
          {
            id : 9,
            name : '车你六爸',
            state : true,
            stateNum : 1,
            url : 'workloadReportingDetails'
          }
        ]
      }
  	];


      //🌲的触碰
      $scope.$on('$ionTreeListOtherStyles:ItemClickedOs', function(event, item) {
        // 捕捉到你点击的那个元素
        if (item.url) {
          $state.go(item.url, {id : item.id, type : 'S'});
        }
      });

    });


  return controller;
});
